/*
 *  Mingyu Shi wrote this.  Copyright (c) 2000 Washington University
 */

// CUSTOM INCLUDES
#include "Normal.h"
#include "Survival.h"

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <math.h>
#include <iostream.h>
// OPENGL INCLUDES
//#include <GL/Glos.h>
//#include <GL/glaux.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#define TRUE 1
#define FALSE 0

#define GAP			10
#define MainWidth	1000
#define MainHeight	700
#define UpperHeight	550
#define LowerHeight	150

#define Y_GAP		40
#define Y_Line1		60
#define Y_Line2		100
#define Y_Line3		140
#define Y_Line4		180
#define Y_Line5		220
#define Y_Line6		260
#define Y_Line7		300
#define Y_Line8		340
#define Y_Line9		380
#define Y_Line10	420
#define Y_Line11	460
#define Y_Line12	500
#define Y_Line13	540
#define Y_Line14	580
#define Y_Line15	620
#define Y_Line16	660

#define X_Column0	25
#define X_Column1	50
#define X_Column2	75
#define X_Column3	100
#define X_Column4	125
#define X_Column_Mean	450
#define X_Column_Var	600

// Window Parameters
extern int CreditInterface;
extern int MainInterface;
extern int main_w,  control_w, broadcast_w, temp_w;

// ftoa: convert a floating point number to ascii.
// itoa: convert a integer number to ascii.      
//
void ftoa(float i);
void itoa(int i);
void ftoa_a(float f);
char* trimString(char* str1);
void InputBound();	
//
// clearString: clears the contents of a string
//
void clearString(char * string);

//
// bitmap_output: Function to draw characters in
//        opengl using the glut toolkit
//
void bitmap_output(int x, int y, char *string, void *font);

///////////////////////////////////////////////////////////////////////////////
//																			 //
//                         Broadcast Window Functions						 //
//																			 //
///////////////////////////////////////////////////////////////////////////////
//
// displayBroadcast: display callback for the graphics
//        window.
void displayBroadcast(void);

// BroadcastKey: Function to handle keyboard events for input
//        in to the program via the broadcast window.
//
void BroadcastKey(unsigned char key, int x, int y);

///////////////////////////////////////////////////////////////////////////////
//																			 //
//                         Controls Window Functions						 //
//																			 //
///////////////////////////////////////////////////////////////////////////////

//
// displayControls: display callback to manage the display 
//        of controls window
//
void displayControls(void);


//
// ControalMouse: function to determine which choice is clicked,
//      and what to do about it.
//
void ControlMouse(int b, int s, int x, int y);

//
//	ControlMousePassive: Passive window function to determine 
//      when the mouse passes over a selection choice.  If so, the 
//      choice is highlighted.
// 
void ControlMousePassive(int x, int y);

///////////////////////////////////////////////////////////////////////////////
//																			 //
//                         Credits Window Functions							 //
//																			 //
///////////////////////////////////////////////////////////////////////////////


//
// displayCredits: Function to handle the display of the credits
//            window presented when the program is started.
//
void displayCredits(void);

//
// reshapeCredits: This is needed because the credits window is a 
//          root level window.
// 
void reshapeCredits(int w, int h);

//
// CreditMouse: Function to handle the click to begin the program
//
void CreditMouse(int b, int s, int x, int y);


///////////////////////////////////////////////////////////////////////////////
//																			 //
//                         Shared Window Functions							 //
//																			 //
///////////////////////////////////////////////////////////////////////////////


//
// Generic display callback 
//
void display(void);
//
// Generic IsVisable callback
//
void vis(int visState);

//
// Generic IsVisable callback
//
void visCredit(int visState);

//
// General reshape function to handle creation
// and managment of the root interface window.
//
void reshape(int w, int h);

//
// Function to initialize and pop the main
// interface window.
//
void BuildInterface(void);

//
// Exit function for the 3D and credit winodows.
//
void ExitKey(unsigned char key, int x, int y);


/////////////////////////
// Math function
//
void getSquare(double x);

//
//	Desicion Functions:
//
void NormalDecisionRule(EndNormal *, EndNormal *);

void Design_Symm_Normal(EndNormal *, EndNormal *);

void Design_NonSymm_Normal(EndNormal *, EndNormal *);

double *symm_prob_count(double *, double *, double *, double *, EndNormal *);

double *nonsymm_prob_count(double *, double *,double *, double *, EndNormal *);


/////////////////////
void Uni_endpoint( );
//the main function for the Uni-endpoint case


void information();

int maxInt(int, int);
int minInt(int, int);


double *SSInfoNew(int, int);
// the new version of transformation.

double * SSInfo(int, int);
// Information "translation"


void TwoSurvival();

void OutNormal(EndNormal *);

void NorSurvival();


void SurNormal();



//Ancillary Function:
double Sample_QuanA(int, double *, double);


float ranA1(long *);


double* ExpGeneratorA(int , double );
