
#define IA 16807
#define IM 2147483647
#define AM (1.0/IM)
#define IQ 127773
#define IR 2836
#define NTAB 32
#define NDIV (1+(IM-1)/NTAB)
#define EPS 1.2e-7
#define RNMX (1.0-EPS)


#include "Interface.h"
//#include <GL/Glos.h>
//#include <GL/glaux.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

// GLOBALS
int NextActive = FALSE;
int ReturnActive = FALSE;
int CalculateActive = FALSE;
int ExitActive = FALSE;

int  ActiveType = FALSE;
int  BroadcastOption = 100;
int  stringcounter = 0;
char BroadcastString[256];
char BroadcastValueString[256];
char BroadcastValueStr1[256];
char BroadcastValueStr2[256];
char BroadcastResultString[256]="";

int InputAllowed = FALSE;
int ActiveQsnIndex = 0;


//------------------Some Global variables-------------
int num_endpoint;
EndNormal *NormalEnd1, *NormalEnd2;
UniSurvival *SurvivalEnd1, *SurvivalEnd2;

int caseIndex = 0;	// case indicator 1,2,3 only;

double result_OneStageNormal;
int count1_information=0;
int count2_information=0;
int count3_inform=0;
int count4_inform=0;
//----------------------------------------------------

//
// bitmap_output: Function to draw characters in
//        opengl using the glut toolkit
//
void bitmap_output(int x, int y, char *string, void *font)
{
  int len, i;

  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) {
    glutBitmapCharacter(font, string[i]);
  }
}

//
// clearString: clears the contents of a string
//
void clearString(char * string)
{
	int len, i;
	len = (int) strlen(string);
	for (i=0;i< len; i++){
		string[i] = ' ';
	}
}

//
// Exit Function for the credit windows
//
void ExitKey(unsigned char key, int x, int y)
{
	if (CreditInterface == TRUE){	// Only do something if we are supposed to!

		if (key == '\r'){			// Wait for a carrige return
			glutDestroyWindow(temp_w);
			CreditInterface = FALSE;

			if(MainInterface == FALSE){
				BuildInterface();
				MainInterface = TRUE;
			}
		}
	}

}

//
// CreditMouse: Function to handle the click to begin the program
//
void CreditMouse(int b, int s, int x, int y)
{
  if (s == GLUT_DOWN){
    switch (b) {
    case GLUT_LEFT_BUTTON:
		if(CreditInterface == TRUE){
			glutDestroyWindow(temp_w);
			CreditInterface = FALSE;
		}

		if(MainInterface == FALSE){
			BuildInterface();
			MainInterface = TRUE;
		}

      break;
    case GLUT_MIDDLE_BUTTON:
      break;
    }
  }

  else {
    switch (b) {
    case GLUT_LEFT_BUTTON:
      break;
    case GLUT_MIDDLE_BUTTON:
      break;
    }
  }
}

//
// Generic IsVisable callback
//
void vis(int visState)
{
  // Nothing needed here for now.
}

//
// Generic IsVisable callback
//
void visCredit(int visState)
{
  // Nothing needed here for now.
}

//
// reshapeCredits: This is needed because the credits window is a
//          root level window.
//
void reshapeCredits(int w, int h)
{
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, w, 0, h);
  glScalef(1, -1, 1);
  glTranslatef(0, -h, 0);
  glMatrixMode(GL_MODELVIEW);

}

//
// General reshape function to handle creation
// and managment of the root interface window.
//
void reshape(int w, int h)
{
  int width = 50;
  int height = 50;

  //////////////////////////////////////
  // Setup the broadcast sub-window
  glutSetWindow(broadcast_w);
  glutPositionWindow(GAP, GAP);
  glutReshapeWindow(MainWidth-2*GAP, UpperHeight-2*GAP);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, w, 0, h);
  glScalef(1, -1, 1);
  glTranslatef(0, -h, 0);
  glMatrixMode(GL_MODELVIEW);

  //////////////////////////////////////
  // Setup the control sub-window
  glutSetWindow(control_w);
  glutPositionWindow(GAP, UpperHeight);
  glutReshapeWindow(MainWidth-2*GAP, LowerHeight-GAP);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, w, 0, h);
  glScalef(1, -1, 1);
  glTranslatef(0, -h, 0);
  glMatrixMode(GL_MODELVIEW);

}



///////////////////////////////////////////////////////////////////////////////
//																			 //
//                         Credits Window Functions							 //
//																			 //
///////////////////////////////////////////////////////////////////////////////
//
// displayCredits: Function to handle the display of the credits
//            window presented when the program is started.
//

void displayCredits(void)
{
  glClear(GL_COLOR_BUFFER_BIT);
  glColor3f(1,0,0);

  //////////////////////////////////////
  // The Credits!
  bitmap_output(60, 50, "Design of Group Sequential Clinical Trials with Multiple Endpoints",
    GLUT_BITMAP_HELVETICA_18);
  bitmap_output(60, 100, "Version 1.0",
    GLUT_BITMAP_HELVETICA_18);
  bitmap_output(60, 180, "Section I: Calculations of Sample Size and Critical Boundaries",
	  GLUT_BITMAP_HELVETICA_18);
  bitmap_output(60, 310, "CopyRight(R) Shuangge Ma and Micheal Kosorok 2002",
	  GLUT_BITMAP_HELVETICA_18);
  
	  
  bitmap_output(60, 340, "Department of Biostatistics and Medical Informatics",
    GLUT_BITMAP_HELVETICA_18);
  bitmap_output(60, 370, "University of Wisconsin--Madison",
    GLUT_BITMAP_HELVETICA_18);

  glFlush();
  glutSwapBuffers();		// Swap Buffers
}

//
// Function to initialize and pop the main
// interface window.
//
void BuildInterface(void)
{
	NormalEnd1 = new EndNormal;
	NormalEnd2 = new EndNormal;
	SurvivalEnd1 = new UniSurvival;
	SurvivalEnd2 = new UniSurvival;

  glutInitWindowPosition(10,10);
  glutInitWindowSize(MainWidth, MainHeight);

  ///////////////////////////////////////////
  // Initialize the main window
  main_w = glutCreateWindow("Software Name (Version 1.01)");
  glutDisplayFunc(display);
  glutVisibilityFunc(vis);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(BroadcastKey);
  glClearColor(0.0, 0.0, (float)0.4, 1.0);

  ///////////////////////////////////////////
  // Initialize the broadcast sub-window
  broadcast_w = glutCreateSubWindow(main_w, GAP, GAP, MainWidth-2*GAP, UpperHeight-2*GAP);
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
  glutDisplayFunc(displayBroadcast);
  glutKeyboardFunc(BroadcastKey);
  glutVisibilityFunc(vis);
  glClearColor(0.0, 0.0, 0.0, 0.0);

  ///////////////////////////////////////////
  // Initialize the control sub-window
  control_w = glutCreateSubWindow(main_w, GAP, UpperHeight, MainWidth-2*GAP, LowerHeight-GAP);
  glutDisplayFunc(displayControls);
  glutVisibilityFunc(vis);
  glutPassiveMotionFunc(ControlMousePassive);
  glutMouseFunc(ControlMouse);
  glClearColor(0.0, 0.0, 0.0, 0.0);

}


///////////////////////////////////////////////////////////////////////////////
//																			 //
//                         Shared Window Functions							 //
//																			 //
///////////////////////////////////////////////////////////////////////////////


//
// Generic display callback
//
void display(void)
{
  //cerr << "Display Callback!" << endl;
  glClear(GL_COLOR_BUFFER_BIT);
  glFlush();
  glutSwapBuffers();
  displayBroadcast();
  displayControls();
}


void displayBroadcast(void)
{

  glutSetWindow(broadcast_w);	// Make sure we are dealing with the right window
  glClear(GL_COLOR_BUFFER_BIT);

  glColor3f(0,1,0);						// highlight it, otherwise don't!

  switch(BroadcastOption){

  case 0:
	  ActiveQsnIndex = 0;
	  InputAllowed = FALSE;
	  bitmap_output(300, Y_Line2, "Section I -- Design of Group Sequential Clinical Trials",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(75, Y_Line4, "Minial Sample Size and Corresponding Critical Boundaries Calculation:",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(75, Y_Line6, "Core Steps:",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(100, Y_Line7, "1. Sample size and Critical boundary calculation for each endpoint.",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(100, Y_Line8, "2. Multiple decision rules are used to control overall alpha and beta spending.",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(100, Y_Line9, "3. Key assumptions: independent endpoints; equal sample sizes in control and treatment groups.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line13, "Please click the \"Next\" to go the the next page.",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 100:
	  ActiveQsnIndex = 10;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "How many endpionts do you have (1 or 2)?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the number of endpoints:",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 101:
	  ActiveQsnIndex = 10;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Unrecognized number of endpoint.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Try to choose from 1 or 2 agian:",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 200:
	  ActiveQsnIndex = 20;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Choose the response type: Normal or Survival (N or S):",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 201:
	  ActiveQsnIndex = 20;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Unrecognized type of endpoint!",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Try to choose from N or S again:",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 250:
	  ActiveQsnIndex = 25;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Case Selection:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line6, "Case 1. Two Normal Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line7, "Case 2. Two Survival Endpoints.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line8, "Case 3. A Normal Endpoint(1st) and a Survival Endpoint(2nd).",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column2, Y_Line9, "Case 4. A Survival Endpoint(1st) and a Normal Endpoint(2nd).",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please select(1, 2, 3 or 4):",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;


  case 260:
	  ActiveQsnIndex = 26;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "What's the decision rule, hard or soft?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Choose either \"h\" or \"s\":",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 270:
	  ActiveQsnIndex = 27;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Select the hard alternatives you want to contorl the type II error:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "(1) H-0, (2) H+0, (3) H0+, (4) H0-, (5) H-+, (6) H++, (7) H--, (8) H+-",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the indices here:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

//////////////////////////////////////////////////////////////////////////////////////////
// One Normal Endpoint						
// first 2 digits indicats case   "11" means one endpoints, normal type
  case 110100:
	  ActiveQsnIndex = 11010;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of this endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "How many looks does this trial have? (An integer between 1 and 10)",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 110101:
	  ActiveQsnIndex = 11010;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of look is out of range !!! Re-enter now.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 110200:
	  ActiveQsnIndex = 11020;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "How many Monto Carlo replications do you want to execute?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 110300:
	  ActiveQsnIndex = 11030;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the mean for this endpoint under the Null Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Mean:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 110400:
	  ActiveQsnIndex = 11040;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks this trial has:",
		  GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the variance for the endpoint under Null Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Var:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 110500:
	  ActiveQsnIndex = 11050;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  	  bitmap_output(X_Column1, Y_Line8, "Please input the mean for the endpoint under the Alternative Hypothesis (positive)",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Mean_Alter :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 110600:
	  ActiveQsnIndex = 11060;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis (positive case):",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  	  bitmap_output(X_Column1, Y_Line9, "Please input the variance for the endpoint under the Alternative Hypothesis (positive)",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "var_Alter:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 110700:
	  ActiveQsnIndex = 11070;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis (positive case):",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line9, "Please input alpha of the endpoint: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;


  case 110800:
	  ActiveQsnIndex = 11080;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis (positive case):",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "Please input beta of the endpoint: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 110900:
	  ActiveQsnIndex = 11090;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks the trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis (positive case):",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line11, "Please input the spending number (choose from 1, 2, 3 or 4): ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line11, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 110901:
	  ActiveQsnIndex = 11090;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis (positive case):",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
 	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line11, "Please input the spending number again (1,2,3 or 4): ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line11, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 111000:
	  ActiveQsnIndex = 11100;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, NormalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis (positive case):",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line11, "The spending number is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->spending_num);
	  bitmap_output(475, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line14, "Click \"Calculate\" now.",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 111100:
	  ActiveQsnIndex = 11110;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "The initial sample size estimate for the Normal Type endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "sequential test is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(result_OneStageNormal);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line15, "Now you can click \"Next\" to input the information spending.",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 111101:
	  bitmap_output(150, Y_Line4, "Not enough information provided. Please return to the first page.",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 111200:
	  {
	  ActiveQsnIndex = 11120;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Please input relative information spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  bitmap_output(X_Column1, Y_Line4, "event look[   1 ]",
		      GLUT_BITMAP_HELVETICA_18);
	  for (i=0;i<count1_information;i++){
		  itoa(NormalEnd1->event_look[i]);
		  bitmap_output(250, Y_Line4+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1, Y_Line4+(i+1)*Y_GAP, "event look[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+2);
		  bitmap_output(X_Column1+110, Y_Line4+(i+1)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+125, Y_Line4+(i+1)*Y_GAP, "]",
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(200, Y_Line4+count1_information*Y_GAP, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);

	  glFlush();
	  break;
	  }

	case 111300:
	  {
	  ActiveQsnIndex = 11130;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "The information spending is:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<=count1_information;i++){
		  bitmap_output(X_Column1, Y_Line4+(i)*Y_GAP, "event look[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+110, Y_Line4+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+125, Y_Line4+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(NormalEnd1->event_look[i]);
		  bitmap_output(300, Y_Line4+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(500, Y_Line4+(i)*Y_GAP, "inform time[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i);
		  bitmap_output(500+115, Y_Line4+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(630, Y_Line4+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd1->inform_time[i]);
		  bitmap_output(720, Y_Line4+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column1, Y_Line4+count1_information*Y_GAP+10, "_____________________________________________________________________",
		      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+(count1_information+1)*Y_GAP, "Click \"Calculate\". ",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }


  case 111400:
	  {
	  ActiveQsnIndex = 11140;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Sample size:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->sample_size);
	  bitmap_output(450, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line5, "Critical boundaries:",
	      GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<NormalEnd1->num_look;i++){
		  bitmap_output(X_Column4, Y_Line6+(i)*Y_GAP, "Look",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column4+50, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column4+60, Y_Line6+(i)*Y_GAP, ":",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd1->boundary[2*i]);
		  bitmap_output(400, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd1->boundary[2*i+1]);
		  bitmap_output(500, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(500, Y_Line16, "Click \"Next\" to show the boudaries.",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 111500:
	  {
	  ActiveQsnIndex = 11150;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Visual Display of Critical Boundaries",
	      GLUT_BITMAP_HELVETICA_18);

	    int offsetx = 200;
		int offsety = 600;		
		int factor = minInt((MainWidth-400)/(NormalEnd1->num_look+1), (MainHeight-400)/(NormalEnd1->boundary[1]+1));

		glColor3f(1,1,1);
		glLineWidth(2);
	
		glBegin(GL_LINES);
		glVertex3f(0+offsetx,0+offsety,0);
		glVertex3f((NormalEnd1->num_look+1)*factor+offsetx,0+offsety,0);
		glEnd();

		glBegin(GL_LINES);
		glVertex3f(0+offsetx,0+offsety,0);
		glVertex3f(0+offsetx,-factor*(NormalEnd1->boundary[1]+1)+offsety,0);
		glEnd();

		for (int i=0; i<NormalEnd1->num_look+1; i++){
	    itoa(i);
	    bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
		}
		for (int i=0; i<NormalEnd1->boundary[1]+1; i++){
	    itoa(i);
	    bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
		}

	  	glColor3f(1,0,0); 
		glLineWidth(2);
		glBegin(GL_LINE_STRIP);
		for (int i=0; i<NormalEnd1->num_look; i++){
			glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd1->boundary[2*i],0);
		}
		glEnd();

	  	glColor3f(1,1,0); 
		glLineWidth(2);
		glBegin(GL_LINE_STRIP);
		for (int i=0; i<NormalEnd1->num_look; i++){
			glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd1->boundary[2*i+1],0);
		}
		glEnd();
	  break;
	  }

//////////////////////////////////////////////////////////////////////
//  One Survival Endpoint
  case 120100:
	  ActiveQsnIndex=12010;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(200, Y_Line3, "For the time-to-event data, we choose from the following model for the ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(100, Y_Line4, "initial estimate of the sample size.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(100, Y_Line6, "Please choose from the following model based on available information.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line7, "1. The Schonfeld Model",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line8, "2. The RGS:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line9, "3. The Lachin's Model",
	      GLUT_BITMAP_HELVETICA_18);
//	  bitmap_output(250, Y_Line10, "4. The  ***  model",
//	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(100, Y_Line12, "Please input your choice of model(1, 2, or 3): ",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  
  case 120400:	//survival_type = 'r' for RGS
	  ActiveQsnIndex=12040;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, SurvivalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "How many looks does this trial have? (An integer between 1 and 10)",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120401:
	  ActiveQsnIndex = 12040;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, SurvivalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of look is out of range ! Please re-enter.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120410:
	  ActiveQsnIndex = 12041;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, SurvivalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of look this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "How many Monto Carlo replications do you want to execute?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120420:
	  ActiveQsnIndex = 12042;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, SurvivalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the type I error (alpha) of this endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120430:
	  ActiveQsnIndex = 12043;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, SurvivalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The type I error (alpha) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->alpha);
	  bitmap_output(550, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the type II error (beta) of this endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120440:
	  ActiveQsnIndex = 12044;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Number of endpoints : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(num_endpoint);
	  bitmap_output(250, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The response of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(350, Y_Line4, SurvivalEnd1->type,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The type I error (alpha) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->alpha);
	  bitmap_output(550, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The type II error (beta) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->beta);
	  bitmap_output(550, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(700, Y_Line13, "Click \"Next\"",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120450:
	  {
	  ActiveQsnIndex = 12045;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Information Spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Please input the relative information:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  bitmap_output(X_Column1, Y_Line5, "relative information[1]:",
		      GLUT_BITMAP_HELVETICA_18);
	  for (i=0;i<count3_inform;i++){
		  ftoa_a(SurvivalEnd1->inform_time[i]);
		  bitmap_output(250, Y_Line5+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1, Y_Line5+(i+1)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+2);
		  bitmap_output(X_Column1+165, Y_Line5+(i+1)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+180, Y_Line5+(i+1)*Y_GAP, "]",
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(350, Y_Line5+count3_inform*Y_GAP, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);

	  glFlush();
	  break;
	  }

	  case 120460:
	  {
	  ActiveQsnIndex = 12046;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Information Spending is:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<=count3_inform;i++){
		  bitmap_output(X_Column1, Y_Line4+(i)*Y_GAP, "inform time[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+110, Y_Line4+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+125, Y_Line4+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd1->inform_time[i]);
		  bitmap_output(300, Y_Line4+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column1, Y_Line4+count3_inform*Y_GAP+10, "_____________________________________________________________________",
		      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+(count3_inform+1)*Y_GAP, "Click \"Next\".",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 120470:	
	  ActiveQsnIndex=12047;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Please choose the alpha spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line3, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120471:
	  ActiveQsnIndex = 12047;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "Out of range !!! Please re-enter.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Please choose the beta spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line4, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120480:	
	  ActiveQsnIndex=12048;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Please choose the beta spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line4, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120481:
	  ActiveQsnIndex = 12048;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Out of range !!! Re-enter it now",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please choose the beta spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line5, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120490:	
	  ActiveQsnIndex=12049;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "What's the hazard rate under Null hypothesis for this endpoint? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120500:	
	  ActiveQsnIndex=12050;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "What's the hazard rate under Alternative hypothesis for this endpoint? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120510:	
	  ActiveQsnIndex=12051;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "What's the length of patients' entry time for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120520:	
	  ActiveQsnIndex=12052;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->entry);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "What's the length of time to follow up for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120530:	
	  ActiveQsnIndex=12053;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->entry);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The followup for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->followup);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "What's the rate of drop (lambdadrop) for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 120540:	
	  ActiveQsnIndex=12054;
	  InputAllowed=FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line3, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->entry);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The followup for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->followup);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The lambdadrop for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdadrop);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line13, "Click \"Calculate\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 121000:
	  {
	  ActiveQsnIndex = 12100;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Sample size:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->samplesize);
	  bitmap_output(450, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line5, "Critical boundaries:",
	      GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<SurvivalEnd1->num_look;i++){
		  bitmap_output(X_Column4, Y_Line6+(i)*Y_GAP, "Look",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column4+50, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column4+60, Y_Line6+(i)*Y_GAP, ":",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd1->boundary[2*i]);
		  bitmap_output(400, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd1->boundary[2*i+1]);
		  bitmap_output(500, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(500, Y_Line15, "Click \"Next\" to view the boudaries:",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 121100:
	  {
	  ActiveQsnIndex = 12110;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Visual Display of Critical Boundaries",
	      GLUT_BITMAP_HELVETICA_18);

	    int offsetx = 200;
		int offsety = 600;		
		int factor = minInt((MainWidth-400)/(SurvivalEnd1->num_look+1), (MainHeight-400)/(SurvivalEnd1->boundary[1]+1));

		glColor3f(1,1,1);
		glLineWidth(2);
	
		glBegin(GL_LINES);
		glVertex3f(0+offsetx,0+offsety,0);
		glVertex3f((SurvivalEnd1->num_look+1)*factor+offsetx,0+offsety,0);
		glEnd();

		glBegin(GL_LINES);
		glVertex3f(0+offsetx,0+offsety,0);
		glVertex3f(0+offsetx,-factor*(SurvivalEnd1->boundary[1]+1)+offsety,0);
		glEnd();

		for (int i=0; i<SurvivalEnd1->num_look+1; i++){
	    itoa(i);
	    bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
		}
		for (int i=0; i<SurvivalEnd1->boundary[1]+1; i++){
	    itoa(i);
	    bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
		        GLUT_BITMAP_HELVETICA_18);
		}

	  	glColor3f(1,0,0); 
		glLineWidth(2);
		glBegin(GL_LINE_STRIP);
		for (int i=0; i<SurvivalEnd1->num_look; i++){
			glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd1->boundary[2*i],0);
		}
		glEnd();

	  	glColor3f(1,1,0); 
		glLineWidth(2);
		glBegin(GL_LINE_STRIP);
		for (int i=0; i<SurvivalEnd1->num_look; i++){
			glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd1->boundary[2*i+1],0);
		}
		glEnd();
	  break;
	  }

//////////////////////////////////////////////////////////////////////
//  Two Normal Endpoints
  case 210100:
	  ActiveQsnIndex = 21010;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "How many looks does this trial have? (An integer between 1 and 10)",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 210101:
	  ActiveQsnIndex = 21010;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of look is out of range !!! Pleasr re-enter.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 210200:
	  ActiveQsnIndex = 21020;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "How many Monto Carlo replications do you want to execute?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 210300:
	  ActiveQsnIndex = 21030;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the mean for the endpoint under the Null Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Mean :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 210400:
	  ActiveQsnIndex = 21040;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the variance for the endpoint under Null Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Var :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 210500:
	  ActiveQsnIndex = 21050;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  	  bitmap_output(X_Column1, Y_Line8, "Please input the mean for the endpoint under the Alternative Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "mean :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 210600:
	  ActiveQsnIndex = 21060;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  	  bitmap_output(X_Column1, Y_Line9, "Please input the variance for the endpoint under the Alternative Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Var:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 210700:
	  ActiveQsnIndex = 21070;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line9, "Please input alpha of the endpoint: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;


  case 210800:
	  ActiveQsnIndex = 21080;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "Please input beta of the endpoint: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 210900:
	  ActiveQsnIndex = 21090;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line11, "Please input the alpha (beta) spending number (1, 2, 3 or 4): ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line11, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 210901:
	  ActiveQsnIndex = 21090;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
 	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line11, "Please input the alpha (beta) spending number again (1,2,3 or 4): ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(730, Y_Line11, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 211000:
	  ActiveQsnIndex = 21100;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
 	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "The alpha (beta) spending number is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->spending_num);
	  bitmap_output(575, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line14, "Please click \"next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 211100:
	  {
	  ActiveQsnIndex = 21110;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the relative information spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  bitmap_output(X_Column1, Y_Line6, "relative information[ 1 ]:",
		      GLUT_BITMAP_HELVETICA_18);
	  for (i=0;i<count1_information;i++){
		  itoa(NormalEnd1->event_look[i]);
		  bitmap_output(350, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1, Y_Line6+(i+1)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+2);
		  bitmap_output(X_Column1+170, Y_Line6+(i+1)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i+1)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(400, Y_Line6+count1_information*Y_GAP, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);

	  glFlush();
	  break;
	  }

	case 211200:
	  {
	  ActiveQsnIndex = 21120;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Information Spending",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<=count1_information;i++){
		  bitmap_output(X_Column1, Y_Line6+(i)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+170, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(NormalEnd1->event_look[i]);
		  bitmap_output(300, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(500, Y_Line6+(i)*Y_GAP, "information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(500+115, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(630, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd1->inform_time[i]);
		  bitmap_output(720, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column1, Y_Line6+count1_information*Y_GAP+10, "_____________________________________________________________________",
		      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+(count1_information+1)*Y_GAP, "Click \"Next\" to inputing information for the 2nd endpoint.",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }


/////////////////////the second point of case 21//////////////////////
  case 212200:
	  ActiveQsnIndex = 21220;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "How Monto Carlo replications do you want to execute?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 212300:
	  ActiveQsnIndex = 21230;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the mean for the endpoint under the Null Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Mean :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  break;

 case 212400:
	  ActiveQsnIndex = 21240;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(3850, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the variance for the endpoint under Null Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Var :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 212500:
	  ActiveQsnIndex = 21250;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  	  bitmap_output(X_Column1, Y_Line8, "Please input the mean for the endpoint under the Alternative Hypothesis ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Mean Alter :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 212600:
	  ActiveQsnIndex = 21260;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  	  bitmap_output(X_Column1, Y_Line9, "Please input the variance for the endpoint under the Alternative Hypothesis ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Var Alter:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 212700:
	  ActiveQsnIndex = 21270;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line9, "Please input alpha of the endpoint: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;


  case 212800:
	  ActiveQsnIndex = 21280;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "Please input beta of the endpoint: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 212900:
	  ActiveQsnIndex = 21290;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line11, "Please input the alpha (beta) spending number (1, 2, 3 or 4): ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line11, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 212901:
	  ActiveQsnIndex = 21290;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
 	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line11, "Please input the alpha (beta) spending number again (1,2,3 or 4): ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(730, Y_Line11, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 213000:
	  ActiveQsnIndex = 21300;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
 	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "The alpha(beta) spending number is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->spending_num);
	  bitmap_output(575, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line14, "Please click \"next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 213100:
	  {
	  ActiveQsnIndex = 21310;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the relative information spending",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  bitmap_output(X_Column1, Y_Line6, "relative information[ 1 ]:",
		      GLUT_BITMAP_HELVETICA_18);
	  for (i=0;i<count2_information;i++){
		  itoa(NormalEnd2->event_look[i]);
		  bitmap_output(350, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1, Y_Line6+(i+1)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+170, Y_Line6+(i+1)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i+1)*Y_GAP, "]",
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(400, Y_Line6+count2_information*Y_GAP, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);

	  glFlush();
	  break;
	  }

	case 213200:
	  {
	  ActiveQsnIndex = 21320;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Information Spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<=count2_information;i++){
		  bitmap_output(X_Column1, Y_Line6+(i)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+170, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(NormalEnd2->event_look[i]);
		  bitmap_output(300, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(500, Y_Line6+(i)*Y_GAP, "information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(500+115, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(630, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd2->inform_time[i]);
		  bitmap_output(720, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column1, Y_Line6+count2_information*Y_GAP+10, "_____________________________________________________________________",
		      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+(count2_information+1)*Y_GAP, "Click \"Next\".",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

	case 215100:
	  ActiveQsnIndex=21510;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Please input the correlation between the two endpoints",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line4, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 215200:
	  ActiveQsnIndex=21520;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the global alpha:",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line5, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 215300:
	  ActiveQsnIndex=21530;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The global alpha is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->Bi_Alpha);
	  bitmap_output(600, Y_Line5, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input the global beta",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line6, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 215400:
	  ActiveQsnIndex=21540;
	  InputAllowed=FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 1: Two Normal Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The global alpha is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->Bi_Alpha);
	  bitmap_output(600, Y_Line5, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The global beta is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->Bi_Beta);
	  bitmap_output(600, Y_Line6, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Click \"Next\". ",
		  GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 216000:
	  {
	  ActiveQsnIndex = 21600;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Sample size:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->sample_size);
	  bitmap_output(450, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line5, "Critical boundaries:",
	      GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<NormalEnd1->num_look;i++){
		  bitmap_output(X_Column4, Y_Line6+(i)*Y_GAP, "Look",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column4+50, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column4+60, Y_Line6+(i)*Y_GAP, ":",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd1->boundary[2*i]);
		  bitmap_output(300, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd1->boundary[2*i+1]);
		  bitmap_output(400, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(500, Y_Line6+(i)*Y_GAP, "|",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd2->boundary[2*i]);
		  bitmap_output(600, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd2->boundary[2*i+1]);
		  bitmap_output(700, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(500, Y_Line15, "Click \"Next\" to view the boudaries",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

	case 216100:
	  {
	  ActiveQsnIndex = 21610;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Visual Display of Critical Boundaries",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line5, "Red line represents the 1st endpoint; yellow line represents the 2nd endpoint.",
	      GLUT_BITMAP_HELVETICA_18);

      int offsetx = 200;
	  int offsety = 600;		
	  int factor = minInt((MainWidth-400)/(NormalEnd1->num_look+1), 
	    	minInt((MainHeight-400)/(NormalEnd1->boundary[1]+1),(MainHeight-400)/(NormalEnd2->boundary[1]+1)));

	  glColor3f(1,1,1);
	  glLineWidth(2);
	
	  glBegin(GL_LINES);
	  glVertex3f(0+offsetx,0+offsety,0);
	  glVertex3f((NormalEnd1->num_look+1)*factor+offsetx,0+offsety,0);
	  glEnd();

	  glBegin(GL_LINES);
	  glVertex3f(0+offsetx,0+offsety,0);
	  glVertex3f(0+offsetx,-factor*(NormalEnd1->boundary[1]+1)+offsety,0);
	  glEnd();

	  for (int i=0; i<NormalEnd1->num_look+1; i++){
		  itoa(i);
	      bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
			  GLUT_BITMAP_HELVETICA_18);
	  }
	  for (int i=0; i<maxInt(NormalEnd1->boundary[1], NormalEnd2->boundary[1])+1; i++){
		  itoa(i);
		  bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
			  GLUT_BITMAP_HELVETICA_18);
	  }

	  glColor3f(1,0,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<NormalEnd1->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd1->boundary[2*i],0);
	  }
	  glEnd();

	  glColor3f(1,0,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<NormalEnd1->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd1->boundary[2*i+1],0);
	  }
	  glEnd();
	  
	  glColor3f(1,1,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<NormalEnd2->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd2->boundary[2*i],0);
	  }
	  glEnd();

	  glColor3f(1,1,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<NormalEnd2->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd2->boundary[2*i+1],0);
	  }
	  glEnd();	
	  break;
	  }

///////////////////////////////////////////////////////////////////////////////
//
//    Two Survival Endpoints, case 22
//
///////////////////////////////////////////////////////////////////////////////
	case 220400:	//survival_type = 'r' for RGS
	  ActiveQsnIndex=22040;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "How many looks does the trial have? (An integer between 1 and 10)",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220401:
	  ActiveQsnIndex = 22040;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks is out of range !!! Please re-enter.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220410:
	  ActiveQsnIndex = 22041;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "How many Monto Carlo replications do you want to execute?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(380, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220420:
	  ActiveQsnIndex = 22042;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input alpha of this endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220430:
	  ActiveQsnIndex = 22043;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The alpha of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->alpha);
	  bitmap_output(550, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the beta of this endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220440:
	  ActiveQsnIndex = 22044;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The alpha of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->alpha);
	  bitmap_output(550, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The beta of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->beta);
	  bitmap_output(550, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(700, Y_Line13, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220450:
	  {
	  ActiveQsnIndex = 22045;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please Input Information Spending",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input the relative information:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  bitmap_output(X_Column1, Y_Line7, "relative information[ 1 ]:",
		      GLUT_BITMAP_HELVETICA_18);
	  for (i=0;i<count3_inform;i++){
		  ftoa_a(SurvivalEnd1->inform_time[i]);
		  bitmap_output(350, Y_Line7+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1, Y_Line7+(i+1)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+2);
		  bitmap_output(X_Column1+170, Y_Line7+(i+1)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line7+(i+1)*Y_GAP, "]",
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(400, Y_Line7+count3_inform*Y_GAP, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);

	  glFlush();
	  break;
	  }

	  case 220460:
	  {
	  ActiveQsnIndex = 22046;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Information Spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<=count3_inform;i++){
		  bitmap_output(X_Column1, Y_Line6+(i)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+170, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd1->inform_time[i]);
		  bitmap_output(400, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column1, Y_Line6+count3_inform*Y_GAP+10, "_____________________________________________________________________",
		      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+(count3_inform+1)*Y_GAP, "Click \"Next\".",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 220470:	
	  ActiveQsnIndex=22047;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please choose the alpha spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line5, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220471:
	  ActiveQsnIndex = 22047;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Out of range ! Please re-enter.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please choose the alpha spending function: (An integer not larger than 5) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220480:	
	  ActiveQsnIndex=22048;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please choose the beta spending function: (An integer not larger than 4)",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220481:
	  ActiveQsnIndex = 22048;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Out of range ! Please re-enter it now",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please choose the beta spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220490:	
	  ActiveQsnIndex=22049;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "What's the hazard rate under Null hypothesis for this endpoint? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220500:	
	  ActiveQsnIndex=22050;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "What's the hazrad rate under Alternative hypothesis for this endpoint? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220510:	
	  ActiveQsnIndex=22051;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "What's the length of patients' entry time for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220520:	
	  ActiveQsnIndex=22052;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "What's the length of time to follow up for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line11, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220530:	
	  ActiveQsnIndex=22053;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "The followup for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->followup);
	  bitmap_output(500, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "What's the rate of drop (lambdadrop) for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line12, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line12, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 220540:	
	  ActiveQsnIndex=22054;
	  InputAllowed=FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "The followup for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->followup);
	  bitmap_output(500, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "The lambdadrop for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdadrop);
	  bitmap_output(500, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line13, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	  ////////////////////////////////////////////////
	  ///// Case 22: two survival endpoints, the 2nd 

  case 222410:
	  ActiveQsnIndex = 22241;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "How many times of Monto Carlo replications do you want to execute?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222420:
	  ActiveQsnIndex = 22242;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the type I error (alpha) of this endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222430:
	  ActiveQsnIndex = 22243;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The type I error (alpha) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->alpha);
	  bitmap_output(550, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the type II error (beta) of this endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222440:
	  ActiveQsnIndex = 22244;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The type I error (alpha) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->alpha);
	  bitmap_output(550, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The type II error (beta) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->beta);
	  bitmap_output(550, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(700, Y_Line13, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222450:
	  {
	  ActiveQsnIndex = 22245;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Information Spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input the relative information:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  bitmap_output(X_Column1, Y_Line7, "relative information[ 0 ]:",
		      GLUT_BITMAP_HELVETICA_18);
	  for (i=0;i<count4_inform;i++){
		  ftoa_a(SurvivalEnd2->inform_time[i]);
		  bitmap_output(350, Y_Line7+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1, Y_Line7+(i+1)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+170, Y_Line7+(i+1)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line7+(i+1)*Y_GAP, "]",
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(400, Y_Line7+count4_inform*Y_GAP, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);

	  glFlush();
	  break;
	  }

	  case 222460:
	  {
	  ActiveQsnIndex = 22246;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Information Spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<=count4_inform;i++){
		  bitmap_output(X_Column1, Y_Line6+(i)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+170, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd2->inform_time[i]);
		  bitmap_output(300, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column1, Y_Line6+count4_inform*Y_GAP+10, "_____________________________________________________________________",
		      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+(count4_inform+1)*Y_GAP, "Click \"Next\".",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 222470:	
	  ActiveQsnIndex=22247;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please choose the alpha spending function: (An integer not larger than 4)",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line5, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222471:
	  ActiveQsnIndex = 22247;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Out of range ! Please re-enter it now",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please choose the alpha spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222480:	
	  ActiveQsnIndex=22248;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please choose the beta spending fucntion: (An integer not larger than 4)",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222481:
	  ActiveQsnIndex = 22248;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Out of range ! Please re-enter it now",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please choose the beta spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222490:	
	  ActiveQsnIndex=22249;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "What's the hazard rate under Null hypothesis for this endpoint? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222500:	
	  ActiveQsnIndex=22250;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "What's the hazard rate under Alternative hypothesis for this endpoint? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222510:	
	  ActiveQsnIndex=22251;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "What's the length of patients' entry time for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222520:	
	  ActiveQsnIndex=22252;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "What's the length of time to follow up for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line11, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222530:	
	  ActiveQsnIndex=22253;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "The followup for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->followup);
	  bitmap_output(500, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "What's the rate of drop for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line12, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line12, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 222540:	
	  ActiveQsnIndex=22254;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "The followup for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->followup);
	  bitmap_output(500, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "The lambdadrop for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdadrop);
	  bitmap_output(500, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line13, "Click \"Next\". ",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 225100:
	  ActiveQsnIndex=22510;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Please input the correlation between the two endpoints",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line4, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 225200:
	  ActiveQsnIndex=22520;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the  global alpha:",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line5, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 225300:
	  ActiveQsnIndex=22530;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The global alpha is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->Bi_Alpha);
	  bitmap_output(600, Y_Line5, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input the global beta:",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line6, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 225400:
	  ActiveQsnIndex=22540;
	  InputAllowed=FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 2: Two Survival Endpoints",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The global alpha is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->Bi_Alpha);
	  bitmap_output(600, Y_Line5, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The global beta is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->Bi_Beta);
	  bitmap_output(600, Y_Line6, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Click \"Calculate\".",
		  GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  
    case 226000:
	  {
	  ActiveQsnIndex = 22600;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Sample size:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->samplesize);
	  bitmap_output(450, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line5, "Critical boundaries:",
	      GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<SurvivalEnd1->num_look;i++){
		  bitmap_output(X_Column4, Y_Line6+(i)*Y_GAP, "Look",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column4+50, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column4+60, Y_Line6+(i)*Y_GAP, ":",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd1->boundary[2*i]);
		  bitmap_output(300, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd1->boundary[2*i+1]);
		  bitmap_output(400, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(500, Y_Line6+(i)*Y_GAP, "|",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd2->boundary[2*i]);
		  bitmap_output(600, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd2->boundary[2*i+1]);
		  bitmap_output(700, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(500, Y_Line15, "Click \"Next\" to view the boudaries.",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

	case 226100:
	  {
	  ActiveQsnIndex = 22610;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Visual Display of Critical Boundaries",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line5, "Red line represents the 1st endpoint, and yellow line represents the 2nd endpoint.",
	      GLUT_BITMAP_HELVETICA_18);

      int offsetx = 200;
	  int offsety = 600;		
	  int factor = minInt((MainWidth-400)/(SurvivalEnd1->num_look+1), 
	    	minInt((MainHeight-400)/(SurvivalEnd1->boundary[1]+1),(MainHeight-400)/(SurvivalEnd2->boundary[1]+1)));

	  glColor3f(1,1,1);
	  glLineWidth(2);
	
	  glBegin(GL_LINES);
	  glVertex3f(0+offsetx,0+offsety,0);
	  glVertex3f((SurvivalEnd1->num_look+1)*factor+offsetx,0+offsety,0);
	  glEnd();

	  glBegin(GL_LINES);
	  glVertex3f(0+offsetx,0+offsety,0);
	  glVertex3f(0+offsetx,-factor*(SurvivalEnd1->boundary[1]+1)+offsety,0);
	  glEnd();

	  for (int i=0; i<SurvivalEnd1->num_look+1; i++){
		  itoa(i);
	      bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
			  GLUT_BITMAP_HELVETICA_18);
	  }
	  for (int i=0; i<maxInt(SurvivalEnd1->boundary[1], SurvivalEnd2->boundary[1])+1; i++){
		  itoa(i);
		  bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
			  GLUT_BITMAP_HELVETICA_18);
	  }

	  glColor3f(1,0,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<SurvivalEnd1->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd1->boundary[2*i],0);
	  }
	  glEnd();

	  glColor3f(1,0,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<SurvivalEnd1->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd1->boundary[2*i+1],0);
	  }
	  glEnd();
	  
	  glColor3f(1,1,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<SurvivalEnd2->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd2->boundary[2*i],0);
	  }
	  glEnd();

	  glColor3f(1,1,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<SurvivalEnd2->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd2->boundary[2*i+1],0);
	  }
	  glEnd();	
	  break;
	  }


///////////////////////////////////////////////////////////////////////////////
//
//    One Normal(1st) and One Survival(2nd) Endpoints, case 23
//
///////////////////////////////////////////////////////////////////////////////
  case 230100:
	  ActiveQsnIndex = 23010;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "How many looks does this trial have? (An integer between 1 and 10)",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 230101:
	  ActiveQsnIndex = 23010;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks is out of range ! Please re-enter.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 230200:
	  ActiveQsnIndex = 23020;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "How many Monto Carlo replications do you want to execute?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 230300:
	  ActiveQsnIndex = 23030;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the mean for the endpoint under the Null Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Mean :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 230400:
	  ActiveQsnIndex = 23040;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the variance for the endpoint under Null Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Var :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 230500:
	  ActiveQsnIndex = 23050;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of look the endpoint has is :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  	  bitmap_output(X_Column1, Y_Line8, "Please input the mean for the endpoint under the Alternative Hypothesis ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "mean Alter :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 230600:
	  ActiveQsnIndex = 23060;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  	  bitmap_output(X_Column1, Y_Line9, "Please input the variance for the endpoint under the Alternative Hypothesis ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "var Alter:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 230700:
	  ActiveQsnIndex = 23070;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line9, "Please input the alpha of this endpoint: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;


  case 230800:
	  ActiveQsnIndex = 23080;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The alpha of this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "Please input the beta of this endpoint: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 230900:
	  ActiveQsnIndex = 23090;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line9, "The alpha of this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line11, "Please input the alpha (beta) spending number (1, 2, 3 or 4): ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line11, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 230901:
	  ActiveQsnIndex = 23090;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
 	  bitmap_output(X_Column1, Y_Line9, "The alpha of this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line11, "Please input the alpha(beta) spending number again (1,2,3 or 4): ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line11, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 231000:
	  ActiveQsnIndex = 23100;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
 	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "The spending number is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->spending_num);
	  bitmap_output(475, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line14, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 231100:
	  {
	  ActiveQsnIndex = 23110;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input relative information",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  bitmap_output(X_Column1, Y_Line6, "relative information[ 1 ]:",
		      GLUT_BITMAP_HELVETICA_18);
	  for (i=0;i<count1_information;i++){
		  itoa(NormalEnd1->event_look[i]);
		  bitmap_output(350, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1, Y_Line6+(i+1)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+2);
		  bitmap_output(X_Column1+170, Y_Line6+(i+1)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i+1)*Y_GAP, "]",
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(400, Y_Line6+count1_information*Y_GAP, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);

	  glFlush();
	  break;
	  }

	case 231200:
	  {
	  ActiveQsnIndex = 23120;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints: 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Information Spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<=count1_information;i++){
		  bitmap_output(X_Column1, Y_Line6+(i)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+170, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(NormalEnd1->event_look[i]);
		  bitmap_output(400, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(550, Y_Line6+(i)*Y_GAP, "information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(550+115, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(680, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd1->inform_time[i]);
		  bitmap_output(770, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column1, Y_Line6+count1_information*Y_GAP+10, "_____________________________________________________________________",
		      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+(count1_information+1)*Y_GAP, "Click \"Next\".",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }
/////////////////////
	  ////// case 23: 1st normal, 2nd survival, for the second survival endpoint
  case 232410:
	  ActiveQsnIndex = 23241;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "How many times of Monto Carlo replications do you want to execute?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232420:
	  ActiveQsnIndex = 23242;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the type I error (alpha) of this endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232430:
	  ActiveQsnIndex = 23243;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The type I error (alpha) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->alpha);
	  bitmap_output(550, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the type II error (beta) of this endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232440:
	  ActiveQsnIndex = 23244;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The type I error (alpha) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->alpha);
	  bitmap_output(550, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The type II error (beta) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->beta);
	  bitmap_output(550, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(700, Y_Line13, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232450:
	  {
	  ActiveQsnIndex = 23245;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Informtion Spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input the relative information",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  bitmap_output(X_Column1, Y_Line7, "relative information[ 1 ]:",
		      GLUT_BITMAP_HELVETICA_18);
	  for (i=0;i<count4_inform;i++){
		  ftoa_a(SurvivalEnd2->inform_time[i]);
		  bitmap_output(350, Y_Line7+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1, Y_Line7+(i+1)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+2);
		  bitmap_output(X_Column1+170, Y_Line7+(i+1)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line7+(i+1)*Y_GAP, "]",
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(400, Y_Line7+count4_inform*Y_GAP, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);

	  glFlush();
	  break;
	  }

	  case 232460:
	  {
	  ActiveQsnIndex = 23246;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Information Spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<=count4_inform;i++){
		  bitmap_output(X_Column1, Y_Line6+(i)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+170, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd2->inform_time[i]);
		  bitmap_output(400, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column1, Y_Line6+count4_inform*Y_GAP+10, "_____________________________________________________________________",
		      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+(count4_inform+1)*Y_GAP, "Click \"Next\".",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 232470:	
	  ActiveQsnIndex=23247;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please choose the alpha spending function: (An integer less than 4)",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line5, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232471:
	  ActiveQsnIndex = 23247;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Out of range! Please re-enter it now",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please choose the alpha spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232480:	
	  ActiveQsnIndex=23248;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please choose the beta spending function: (An integer not larger than 4)",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232481:
	  ActiveQsnIndex = 23248;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Out of range! Please re-enter",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please choose the beta spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232490:	
	  ActiveQsnIndex=23249;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "What's the hazard rate under Null hypothesis for this endpoint? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232500:	
	  ActiveQsnIndex=23250;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) for Fhe second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "What's the hazard rate under Alternative hypothesis for this endpoint? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232510:	
	  ActiveQsnIndex=23251;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "What's the length of time patients' entry time for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232520:	
	  ActiveQsnIndex=23252;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "What's the length of time to follow up for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line11, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232530:	
	  ActiveQsnIndex=23253;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "The followup for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->followup);
	  bitmap_output(500, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "What's the rate of drop for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line12, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line12, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 232540:	
	  ActiveQsnIndex=23254;
	  InputAllowed=FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd2->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "The followup for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->followup);
	  bitmap_output(500, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "The lambdadrop for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd2->lambdadrop);
	  bitmap_output(500, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line13, "Click \"Next\". ",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 235100:
	  ActiveQsnIndex=23510;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Please input the correlation between the two endpoints",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line4, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 235200:
	  ActiveQsnIndex=23520;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the global alpha:",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line5, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 235300:
	  ActiveQsnIndex=23530;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The global alpha is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->Bi_Alpha);
	  bitmap_output(600, Y_Line5, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input the global beta",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line6, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 235400:
	  ActiveQsnIndex=23540;
	  InputAllowed=FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 3: Two Endpoints, 1st Normal & 2nd Survival",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The global alpha is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd1->Bi_Alpha);
	  bitmap_output(600, Y_Line5, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The global beta is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->Bi_Beta);
	  bitmap_output(600, Y_Line6, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Click \"Calculate\".",
		  GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 236000:
	  {
	  ActiveQsnIndex = 23600;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Sample size:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd1->sample_size);
	  bitmap_output(450, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line5, "Critical boundaries:",
	      GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<NormalEnd1->num_look;i++){
		  bitmap_output(X_Column4, Y_Line6+(i)*Y_GAP, "Look",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column4+50, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column4+60, Y_Line6+(i)*Y_GAP, ":",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd1->boundary[2*i]);
		  bitmap_output(300, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd1->boundary[2*i+1]);
		  bitmap_output(400, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(500, Y_Line6+(i)*Y_GAP, "|",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd2->boundary[2*i]);
		  bitmap_output(600, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd2->boundary[2*i+1]);
		  bitmap_output(700, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(500, Y_Line15, "Click \"Next\" to view the boudaries",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

	case 236100:
	  {
	  ActiveQsnIndex = 23610;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Visual Display of Critical Boundaries",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line5, "Red line represents the 1st endpoint, and yellow line represents the 2nd endpoint.",
	      GLUT_BITMAP_HELVETICA_18);

      int offsetx = 200;
	  int offsety = 600;		
	  int factor = minInt((MainWidth-400)/(NormalEnd1->num_look+1), 
	    	minInt((MainHeight-400)/(NormalEnd1->boundary[1]+1),(MainHeight-400)/(SurvivalEnd2->boundary[1]+1)));

	  glColor3f(1,1,1);
	  glLineWidth(2);
	
	  glBegin(GL_LINES);
	  glVertex3f(0+offsetx,0+offsety,0);
	  glVertex3f((NormalEnd1->num_look+1)*factor+offsetx,0+offsety,0);
	  glEnd();

	  glBegin(GL_LINES);
	  glVertex3f(0+offsetx,0+offsety,0);
	  glVertex3f(0+offsetx,-factor*(NormalEnd1->boundary[1]+1)+offsety,0);
	  glEnd();

	  for (int i=0; i<NormalEnd1->num_look+1; i++){
		  itoa(i);
	      bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
			  GLUT_BITMAP_HELVETICA_18);
	  }
	  for (int i=0; i<maxInt(NormalEnd1->boundary[1], SurvivalEnd2->boundary[1])+1; i++){
		  itoa(i);
		  bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
			  GLUT_BITMAP_HELVETICA_18);
	  }

	  glColor3f(1,0,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<NormalEnd1->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd1->boundary[2*i],0);
	  }
	  glEnd();

	  glColor3f(1,0,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<NormalEnd1->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd1->boundary[2*i+1],0);
	  }
	  glEnd();
	  
	  glColor3f(1,1,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<SurvivalEnd2->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd2->boundary[2*i],0);
	  }
	  glEnd();

	  glColor3f(1,1,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<SurvivalEnd2->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd2->boundary[2*i+1],0);
	  }
	  glEnd();	
	  break;
	  }

///////////////////////////////////////////////////////////////////////////////
//
//    One Survival(1st) and One Normal(2nd) Endpoints, case 24
//
///////////////////////////////////////////////////////////////////////////////
	case 240400:	//survival_type = 'r' for RGS
	  ActiveQsnIndex=24040;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "How many looks does this trial have? (An integer between 1 and 10)",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240401:
	  ActiveQsnIndex = 24040;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Number of looks is out of range ! Please re-enter.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240410:
	  ActiveQsnIndex = 24041;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "How many Monto Carlo replications do you want to execute?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240420:
	  ActiveQsnIndex = 24042;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the type I error (alpha) of this endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240430:
	  ActiveQsnIndex = 24043;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The type I error (alpha) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->alpha);
	  bitmap_output(550, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the type II error (beta) of this endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(550, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240440:
	  ActiveQsnIndex = 24044;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The number of Monto Carlo replications:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->num_simul);
	  bitmap_output(450, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The type I error (alpha) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->alpha);
	  bitmap_output(550, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The type II error (beta) of the endpoint is :",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->beta);
	  bitmap_output(550, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(700, Y_Line13, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240450:
	  {
	  ActiveQsnIndex = 24045;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Information Spending",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input relative information spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  bitmap_output(X_Column1, Y_Line7, "relative information[1]:",
		      GLUT_BITMAP_HELVETICA_18);
	  for (i=0;i<count3_inform;i++){
		  ftoa_a(SurvivalEnd1->inform_time[i]);
		  bitmap_output(350, Y_Line7+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1, Y_Line7+(i+1)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+2);
		  bitmap_output(X_Column1+170, Y_Line7+(i+1)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line7+(i+1)*Y_GAP, "]",
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(200, Y_Line7+count3_inform*Y_GAP, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);

	  glFlush();
	  break;
	  }

	  case 240460:
	  {
	  ActiveQsnIndex = 24046;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Information Spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<=count3_inform;i++){
		  bitmap_output(X_Column1, Y_Line6+(i)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+170, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd1->inform_time[i]);
		  bitmap_output(300, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column1, Y_Line6+count3_inform*Y_GAP+10, "_____________________________________________________________________",
		      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+(count3_inform+1)*Y_GAP, "Click \"Next\".",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

  case 240470:	
	  ActiveQsnIndex=24047;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please choose alpha spending function: (An integer not larger than 4)",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line5, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240471:
	  ActiveQsnIndex = 24047;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Out of range ! Please re-enter.",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please choose alpha spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240480:	
	  ActiveQsnIndex=24048;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please choose beta spending function: (An integer not larger than 4)",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line6, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240481:
	  ActiveQsnIndex = 24048;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Out of range ! Please re-enter it now",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please choose beta spending function: (An integer not larger than 4) ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(750, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240490:	
	  ActiveQsnIndex=24049;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "What's the hazard rate under Null hypothesis for this endpoint? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240500:	
	  ActiveQsnIndex=24050;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "What's the hazard rate under Alternative hypothesis for this endpoint? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240510:	
	  ActiveQsnIndex=24051;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "What's the length of patients' entry time for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240520:	
	  ActiveQsnIndex=24052;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "What's the length of time to follow up for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line11, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240530:	
	  ActiveQsnIndex=24053;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "The followup for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->followup);
	  bitmap_output(500, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "What's the rate of drop for this trial? ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line12, "Please input here:", 
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line12, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 240540:	
	  ActiveQsnIndex=24054;
	  InputAllowed=FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "1) For the first survival endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The alphaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->alphaSpend);
	  bitmap_output(500, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The betaSpend for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->betaSpend);
	  bitmap_output(500, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "The lambdaNull for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaNull);
	  bitmap_output(500, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "The lambdaAlter for this endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdaAlter);
	  bitmap_output(500, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The entry for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->entry);
	  bitmap_output(500, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "The followup for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->followup);
	  bitmap_output(500, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "The lambdadrop for this trial is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->lambdadrop);
	  bitmap_output(500, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11+10, "_______________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line13, "Click \"Next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

/////////////////////////////////////////////////////////////////////////////
  case 242200:
	  ActiveQsnIndex = 24220;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks the trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "How many Monto Carlo replications  do you want to execute?",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input here : ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line7, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 242300:
	  ActiveQsnIndex = 24230;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "_______________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Please input the mean for the endpoint under the Null Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Mean :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line8, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  break;

 case 242400:
	  ActiveQsnIndex = 24240;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Please input the variance for the endpoint under Null Hypothesis",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "Var :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 242500:
	  ActiveQsnIndex = 24250;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  	  bitmap_output(X_Column1, Y_Line8, "Please input the mean for the endpoint under the Alternative Hypothesis ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "mean Alter :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 242600:
	  ActiveQsnIndex = 24260;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monro Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  	  bitmap_output(X_Column1, Y_Line9, "Please input the variance for the endpoint under the Alternative Hypothesis ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10, "var Alter:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(400, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 242700:
	  ActiveQsnIndex = 24270;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line9, "Please input alpha of the endpoint: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line9, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;


  case 242800:
	  ActiveQsnIndex = 24280;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line9+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "Please input beta of the endpoint: ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(450, Y_Line10, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 242900:
	  ActiveQsnIndex = 24290;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line11, "Please choose the alpha(beta) spending function (1, 2, 3 or 4): ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(700, Y_Line11, trimString(BroadcastValueString),
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 242901:
	  ActiveQsnIndex = 24290;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
 	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line10+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line11, "Please choose the spending function again (1,2,3 or 4): ",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(650, Y_Line11, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 243000:
	  ActiveQsnIndex = 24300;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The number of looks this trial has :",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_look);
	  bitmap_output(400, Y_Line5, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Number of Monto Carlo replications : ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->num_simul);
	  bitmap_output(380, Y_Line6, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Under Null Hypothesis:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line7, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Null);
	  bitmap_output(X_Column_Mean+50, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line7, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Null);
	  bitmap_output(X_Column_Var+80, Y_Line7, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line8, "Under Alternative Hypothesis :",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Mean, Y_Line8, "Mean=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->mean_Alter);
	  bitmap_output(X_Column_Mean+50, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column_Var, Y_Line8, "Variance=",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->var_Alter);
	  bitmap_output(X_Column_Var+80, Y_Line8, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
 	  bitmap_output(X_Column1, Y_Line9, "The alpha of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_alpha);
	  bitmap_output(450, Y_Line9, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
  	  bitmap_output(X_Column1, Y_Line10, "The beta of the endpoint is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(NormalEnd2->overall_beta);
	  bitmap_output(450, Y_Line10, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11, "The spending number is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(NormalEnd2->spending_num);
	  bitmap_output(475, Y_Line11, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line11+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(250, Y_Line14, "Click \"next\".",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

  case 243100:
	  {
	  ActiveQsnIndex = 24310;
	  InputAllowed = TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input relative information spending:",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  bitmap_output(X_Column1, Y_Line6, "relative information[ 1 ]:",
		      GLUT_BITMAP_HELVETICA_18);
	  for (i=0;i<count2_information;i++){
		  itoa(NormalEnd2->event_look[i]);
		  bitmap_output(350, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1, Y_Line6+(i+1)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+2);
		  bitmap_output(X_Column1+170, Y_Line6+(i+1)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i+1)*Y_GAP, "]",
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(400, Y_Line6+count2_information*Y_GAP, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);

	  glFlush();
	  break;
	  }

	case 243200:
	  {
	  ActiveQsnIndex = 24320;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "2) For the second normal endpoint:",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Information Spending :",
		  GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<=count2_information;i++){
		  bitmap_output(X_Column1, Y_Line6+(i)*Y_GAP, "relative information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column1+170, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column1+185, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(NormalEnd2->event_look[i]);
		  bitmap_output(300, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(500, Y_Line6+(i)*Y_GAP, "information[",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(500+115, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(630, Y_Line6+(i)*Y_GAP, "]:",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd2->inform_time[i]);
		  bitmap_output(720, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(X_Column1, Y_Line6+count2_information*Y_GAP+10, "_____________________________________________________________________",
		      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+(count2_information+1)*Y_GAP, "Click \"Next\".",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

	case 245100:
	  ActiveQsnIndex=24510;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line3+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "Please input correlation between the two endpoints",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line4, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 245200:
	  ActiveQsnIndex=24520;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "Please input the global alpha:",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line5, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 245300:
	  ActiveQsnIndex=24530;
	  InputAllowed=TRUE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The global alpha is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->Bi_Alpha);
	  bitmap_output(600, Y_Line5, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "Please input the global beta :",
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(600, Y_Line6, trimString(BroadcastValueString), 
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 245400:
	  ActiveQsnIndex=24540;
	  InputAllowed=FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column0, Y_Line3, "Case 4: Two Endpoints: 1st Survival & 2nd Normal",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line4, "The correlation is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->corr_ph);
	  bitmap_output(600, Y_Line4, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line5, "The gobal alpha is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->Bi_Alpha);
	  bitmap_output(600, Y_Line5, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6, "The global beta is: ",
	      GLUT_BITMAP_HELVETICA_18);
	  ftoa_a(SurvivalEnd1->Bi_Beta);
	  bitmap_output(600, Y_Line6, BroadcastString,
		  GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line6+10, "______________________________________________________________________",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column1, Y_Line7, "Click \"Calculate\".",
		  GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;

	case 246000:
	  {
	  ActiveQsnIndex = 24600;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Sample size:",
	      GLUT_BITMAP_HELVETICA_18);
	  itoa(SurvivalEnd1->samplesize);
	  bitmap_output(450, Y_Line4, BroadcastString,
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line5, "Critical boundaries:",
	      GLUT_BITMAP_HELVETICA_18);
	  int i=0;
	  for (i=0;i<SurvivalEnd1->num_look;i++){
		  bitmap_output(X_Column4, Y_Line6+(i)*Y_GAP, "Look",
		      GLUT_BITMAP_HELVETICA_18);
		  itoa(i+1);
		  bitmap_output(X_Column4+50, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(X_Column4+60, Y_Line6+(i)*Y_GAP, ":",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd1->boundary[2*i]);
		  bitmap_output(300, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(SurvivalEnd1->boundary[2*i+1]);
		  bitmap_output(400, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  bitmap_output(500, Y_Line6+(i)*Y_GAP, "|",
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd2->boundary[2*i]);
		  bitmap_output(600, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
		  ftoa_a(NormalEnd2->boundary[2*i+1]);
		  bitmap_output(700, Y_Line6+(i)*Y_GAP, BroadcastString,
		      GLUT_BITMAP_HELVETICA_18);
	  }
	  bitmap_output(500, Y_Line15, "Click \"Next\" to view the boudaries",
		      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;
	  }

	case 246100:
	  {
	  ActiveQsnIndex = 24610;
	  InputAllowed = FALSE;
	  bitmap_output(X_Column0, Y_Line1, "Step 1 -- Calculation of each endpoint",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line4, "Visual Display of Critical Boundaries",
	      GLUT_BITMAP_HELVETICA_18);
	  bitmap_output(X_Column3, Y_Line5, "Red line represents the 1st endpoint, and yellow line represents the 2nd endpoint.",
	      GLUT_BITMAP_HELVETICA_18);

      int offsetx = 200;
	  int offsety = 600;		
	  int factor = minInt((MainWidth-400)/(SurvivalEnd1->num_look+1), 
	    	minInt((MainHeight-400)/(SurvivalEnd1->boundary[1]+1),(MainHeight-400)/(NormalEnd2->boundary[1]+1)));

	  glColor3f(1,1,1);
	  glLineWidth(2);
	
	  glBegin(GL_LINES);
	  glVertex3f(0+offsetx,0+offsety,0);
	  glVertex3f((SurvivalEnd1->num_look+1)*factor+offsetx,0+offsety,0);
	  glEnd();

	  glBegin(GL_LINES);
	  glVertex3f(0+offsetx,0+offsety,0);
	  glVertex3f(0+offsetx,-factor*(SurvivalEnd1->boundary[1]+1)+offsety,0);
	  glEnd();

	  for (int i=0; i<SurvivalEnd1->num_look+1; i++){
		  itoa(i);
	      bitmap_output(i*factor+offsetx, offsety+30, BroadcastString,
			  GLUT_BITMAP_HELVETICA_18);
	  }
	  for (int i=0; i<maxInt(SurvivalEnd1->boundary[1], NormalEnd2->boundary[1])+1; i++){
		  itoa(i);
		  bitmap_output(-20+offsetx, offsety-factor*i, BroadcastString,
			  GLUT_BITMAP_HELVETICA_18);
	  }

	  glColor3f(1,0,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<SurvivalEnd1->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd1->boundary[2*i],0);
	  }
	  glEnd();

	  glColor3f(1,0,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<SurvivalEnd1->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*SurvivalEnd1->boundary[2*i+1],0);
	  }
	  glEnd();
	  
	  glColor3f(1,1,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<NormalEnd2->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd2->boundary[2*i],0);
	  }
	  glEnd();

	  glColor3f(1,1,0); 
	  glLineWidth(2);
	  glBegin(GL_LINE_STRIP);
	  for (int i=0; i<NormalEnd2->num_look; i++){
		  glVertex3f(factor*(i+1)+offsetx, offsety-factor*NormalEnd2->boundary[2*i+1],0);
	  }
	  glEnd();	
	  break;
	  }


///////////////////////////////////////////////////////////////////////
  case 999999999:
	  bitmap_output(150, Y_Line4, "Please wait for later version.......",
	      GLUT_BITMAP_HELVETICA_18);
	  glFlush();
	  break;


	  }

  glFlush();								// Flush the graphics pipe
  glutSwapBuffers();						// Swap buffers
  //glutSetWindow(broadcast_w);
}


//
// BroadcastKey: Function to handle keyboard events for input
//        in to the program via the broadcast window.
//

void BroadcastKey(unsigned char key, int x, int y)
{
	if(InputAllowed==TRUE){
		switch (ActiveQsnIndex){
		case 10:
			if (key=='1'){
				num_endpoint = key-48;      // change from char to int (-48)
				BroadcastOption = 200;
			}
			else if(key=='2'){
				num_endpoint = key-48;      // change from char to int (-48)
				BroadcastOption = 250;
			}
			else {
				BroadcastOption = 111400;
			}
			displayBroadcast();
			break;


		case 20:
			if(key=='N'||key=='n'){
				NormalEnd1->type = "Normal";
				NormalEnd1->order = 1;
				caseIndex = 11;
				BroadcastOption = 110100;
			}
			else if(key=='S'||key=='s'){
				SurvivalEnd1->type = "Survival";
				SurvivalEnd1->order = 1;
				caseIndex = 12;
				BroadcastOption = 120100;
			}
			else{
				BroadcastOption = 201;
			}
			displayBroadcast();
			break;

		case 25:	
			if(key=='1'){
				caseIndex = 21;
				NormalEnd1->type = "Normal";
				NormalEnd1->order = 1;
				NormalEnd2->type = "Normal";
				NormalEnd2->order = 2;
				BroadcastOption = 260;
			}
			else if (key=='2'){
				caseIndex = 22;
				SurvivalEnd1->type = "Survival";
				SurvivalEnd1->order = 1;
				SurvivalEnd2->type = "Survival";
				SurvivalEnd2->order = 2;
				BroadcastOption = 260;
			}
			else if (key=='3'){
				caseIndex = 23;
				NormalEnd1->type = "Normal";
				NormalEnd1->order = 1;
				SurvivalEnd2->type = "Survival";
				SurvivalEnd2->order = 2;
				BroadcastOption = 260;
			}
			else if (key=='4'){
				caseIndex = 24;
				SurvivalEnd1->type = "Survival";
				SurvivalEnd1->order = 1;
				NormalEnd2->type = "Normal";
				NormalEnd2->order = 2;
				BroadcastOption = 260;
			}
			else {
				BroadcastOption = 999999999;
			}
			displayBroadcast();
			break;

		case 26:
			if(key=='h'||key=='H'){
				if(caseIndex==21){
					NormalEnd1->rule_decision = 1;
					NormalEnd2->rule_decision = 1;
					BroadcastOption = 270;
				}
				else if(caseIndex==22){
					SurvivalEnd1->rule_decision = 1;
					SurvivalEnd2->rule_decision = 1;
					BroadcastOption = 270;
				}
				else if(caseIndex==23){
					NormalEnd1->rule_decision = 1;
					SurvivalEnd2->rule_decision = 1;
					BroadcastOption = 270;
				}
				else if(caseIndex==24){
					SurvivalEnd1->rule_decision = 1;
					NormalEnd2->rule_decision = 1;
					BroadcastOption = 270;
				}
				else{
				}
			}
			else if(key=='s' || key=='S'){
				if(caseIndex==21){
					NormalEnd1->rule_decision = 0;
					NormalEnd2->rule_decision = 0;
					BroadcastOption = 270;
				}
				else if(caseIndex==22){
					SurvivalEnd1->rule_decision = 0;
					SurvivalEnd2->rule_decision = 0;
					BroadcastOption = 270;
				}
				else if(caseIndex==23){
					NormalEnd1->rule_decision = 0;
					SurvivalEnd2->rule_decision = 0;
					BroadcastOption = 270;
				}
				else if(caseIndex==24){
					SurvivalEnd1->rule_decision = 0;
					NormalEnd2->rule_decision = 0;
					BroadcastOption = 270;
				}
				else{
				}
			}
			displayBroadcast();
			break;
		
		case 12010:	
			if(key=='1'){
			//	SurvivalEnd1->survival_type='S';
			//	BroadcastOption = 120200;
				BroadcastOption = 120400;
			}
			else if (key=='2'){
			//	SurvivalEnd1->survival_type='R';
			//	BroadcastOption = 120400;
				BroadcastOption = 120400;
			}
			else if (key=='3'){
			//	SurvivalEnd1->survival_type='F';
			//	BroadcastOption = 120600;
				BroadcastOption = 120400;
			}
			else if (key=='4'){
			//	SurvivalEnd1->survival_type='L';
			//	BroadcastOption = 120800;
				BroadcastOption = 120400;
			}
			else {
				BroadcastOption = 999999999;
			}

			displayBroadcast();
			break;

		case 27:	
		case 11010:
		case 11020:
		case 11030:
		case 11040:
		case 11050:
		case 11060:
		case 11070:
		case 11080:
		case 11090:
		case 11100:
		case 11110:
		case 11120:

		case 12020:
		case 12021:
		case 12022:
		case 12023:
		case 12024:
		case 12025:
		case 12040:
		case 12041:
		case 12042:
		case 12043:
		case 12044:
		case 12045:
		case 12046:
		case 12047:
		case 12048:
		case 12049:
		case 12050:
		case 12051:
		case 12052:
		case 12053:
			
		case 12060:
		case 12061:
		case 12062:
		case 12063:
		case 12064:

		case 21010:
		case 21020:
		case 21030:
		case 21040:
		case 21050:
		case 21060:
		case 21070:
		case 21080:
		case 21090:
		case 21100:
		case 21110:
		case 21120:
		case 21130:
		case 21220:
		case 21230:
		case 21240:
		case 21250:
		case 21260:
		case 21270:
		case 21280:
		case 21290:
		case 21310:
		case 21510:
		case 21520:
		case 21530:

		case 22040:
		case 22041:
		case 22042:
		case 22043:
		case 22044:
		case 22045:
		case 22046:
		case 22047:
		case 22048:
		case 22049:
		case 22050:
		case 22051:
		case 22052:
		case 22053:

		case 22241:
		case 22242:
		case 22243:
		case 22244:
		case 22245:
		case 22246:
		case 22247:
		case 22248:
		case 22249:
		case 22250:
		case 22251:
		case 22252:
		case 22253:

		case 22510:
		case 22520:
		case 22530:

		case 23010:
		case 23020:
		case 23030:
		case 23040:
		case 23050:
		case 23060:
		case 23070:
		case 23080:
		case 23090:
		case 23100:
		case 23110:
		case 23120:

		case 23241:
		case 23242:
		case 23243:
		case 23244:
		case 23245:
		case 23246:
		case 23247:
		case 23248:
		case 23249:
		case 23250:
		case 23251:
		case 23252:
		case 23253:

		case 23510:
		case 23520:
		case 23530:

		case 24040:
		case 24041:
		case 24042:
		case 24043:
		case 24044:
		case 24045:
		case 24046:
		case 24047:
		case 24048:
		case 24049:
		case 24050:
		case 24051:
		case 24052:
		case 24053:

		case 24220:
		case 24230:
		case 24240:
		case 24250:
		case 24260:
		case 24270:
		case 24280:
		case 24290:
		case 24300:
		case 24310:
		case 24320:

		case 24510:
		case 24520:
		case 24530:
		
			if (key != '\r'){		// Wait for a carrige return
				if (key == '\b'){	// If Backspace
					if (stringcounter != 0){
						BroadcastValueString[stringcounter-1] = '\0';
						displayBroadcast();
						stringcounter--;
					}
				}
				else{					// Not a backspace
					if(key>='0'&&key<='9'||key=='.'||key=='-'){
						BroadcastValueString[stringcounter] = key;	
						// store text in BroadcastValueString
						displayBroadcast();
						stringcounter++;
					}
				}
			}

			else {					// if return(enter)
				BroadcastValueString[stringcounter] = '\0';
				switch(ActiveQsnIndex) {
				case 27:
					{
						int *temp_ctrl = new int[8];
						int temp_idx = 0;
						int temp_loop=0;
						for (temp_idx = 0; temp_idx<8; temp_idx++){
							temp_ctrl[temp_idx]=0;
						}
						int n_ctrl = strlen(BroadcastValueString);
//						cout<<"n_ctrl is "<<n_ctrl<<endl;
//						cout<<"BroadcastValueString is "<<BroadcastValueString<<endl;
						while (temp_loop<n_ctrl){
							temp_idx = (int)BroadcastValueString[temp_loop]-48;
							if (temp_idx<0 || temp_idx>8){
							}
							else{
								temp_ctrl[temp_idx-1] = 1;
							}
							temp_loop ++;
						}

						if(caseIndex==21){
							for (temp_idx = 0; temp_idx<8; temp_idx++){
								NormalEnd1->ctrl_ind[temp_idx] = temp_ctrl[temp_idx];
								NormalEnd2->ctrl_ind[temp_idx] = temp_ctrl[temp_idx];
							}
							BroadcastOption = 210100;
						}
						else if(caseIndex==22){
							for (temp_idx = 0; temp_idx<8; temp_idx++){
								SurvivalEnd1->ctrl_ind[temp_idx] = temp_ctrl[temp_idx];
								SurvivalEnd2->ctrl_ind[temp_idx] = temp_ctrl[temp_idx];
							}
							BroadcastOption = 220400;
						}
						else if(caseIndex==23){
							for (temp_idx = 0; temp_idx<8; temp_idx++){
								NormalEnd1->ctrl_ind[temp_idx] = temp_ctrl[temp_idx];
								SurvivalEnd2->ctrl_ind[temp_idx] = temp_ctrl[temp_idx];
							}
							BroadcastOption = 230100;
						}
						else if(caseIndex==24){
							for (temp_idx = 0; temp_idx<8; temp_idx++){
								SurvivalEnd1->ctrl_ind[temp_idx] = temp_ctrl[temp_idx];
								NormalEnd2->ctrl_ind[temp_idx] = temp_ctrl[temp_idx];
							}
							BroadcastOption = 240400;
						}
						else{
						}
						displayBroadcast();
						clearString(BroadcastValueString);
						break;
					}

				case 11010:
					{
					int temp_look = (int) atof(BroadcastValueString);
					if (temp_look>LIMIT_N_LOOK || temp_look<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 110101;
					}
					else {
						NormalEnd1->num_look = temp_look;
						clearString(BroadcastValueString);
						BroadcastOption = 110200;
					}
					break;
					}

				case 11020:
					{
					int temp_simulation = (int) atof(BroadcastValueString);
					temp_simulation = ((int)(temp_simulation/(NormalEnd1->num_look*2)))*(NormalEnd1->num_look*2);
					NormalEnd1->num_simul = temp_simulation;
					NormalEnd1->getLookSimul();
					cout<<"look_simul="<<NormalEnd1->look_simul<<endl;
					clearString(BroadcastValueString);
					BroadcastOption = 110300 ;
					break;
					}

				case 11030:
					{
					NormalEnd1->mean_Null = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 110400;
					break;
					}

				case 11040:
					{
					NormalEnd1->var_Null = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 110500;
					break;
					}

				case 11050:
					{
					NormalEnd1->mean_Alter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 110600;
					break;
					}

				case 11060:
					{
					NormalEnd1->var_Alter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 110700;
					break;
					}

				case 11070:
					{
					NormalEnd1->overall_alpha = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 110800;
					break;
					}

				case 11080:
					{
					NormalEnd1->overall_beta = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 110900;
					break;
					}

				case 11090: 
					{
					NormalEnd1->spending_num = atof(BroadcastValueString);
					if (NormalEnd1->spending_num<1||NormalEnd1->spending_num>4){
						BroadcastOption = 110901;
						NormalEnd1->spending_num = 0;
					}
					else {
						BroadcastOption = 111000;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 11120: 
					{
					NormalEnd1->event_look[count1_information] = atof(BroadcastValueString);
					if (count1_information == NormalEnd1->num_look-1){
						NormalEnd1->information();
						BroadcastOption = 111300;
					}
					else {
						count1_information ++;
						BroadcastOption = 111200;
					}
					clearString(BroadcastValueString);
					break;
					}
					
///////////////////////////////////////////////////////////////////////////////////////////////////
				case 21010:
					{
					int temp_look = (int) atof(BroadcastValueString);
					if (temp_look>LIMIT_N_LOOK || temp_look<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 210101;
					}
					else {
						NormalEnd1->num_look = temp_look;
						NormalEnd2->num_look = temp_look;
						clearString(BroadcastValueString);
						BroadcastOption = 210200;
					}
					break;
					}

				case 21020:
					{
					int temp_simulation = (int) atof(BroadcastValueString);
					temp_simulation = ((int)(temp_simulation/(NormalEnd1->num_look*2)))*(NormalEnd1->num_look*2);
					NormalEnd1->num_simul = temp_simulation;
					NormalEnd1->getLookSimul();
					cout<<"look_simul="<<NormalEnd1->look_simul<<endl;
					clearString(BroadcastValueString);
					BroadcastOption = 210300 ;
					break;
					}

				case 21030:
					{
					NormalEnd1->mean_Null = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 210400;
					break;
					}

				case 21040:
					{
					NormalEnd1->var_Null = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 210500;
					break;
					}

				case 21050:
					{
					NormalEnd1->mean_Alter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 210600;
					break;
					}

				case 21060:
					{
					NormalEnd1->var_Alter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 210700;
					break;
					}

				case 21070:
					{
					NormalEnd1->overall_alpha = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 210800;
					break;
					}

				case 21080:
					{
					NormalEnd1->overall_beta = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 210900;
					break;
					}

				case 21090: 
					{
					NormalEnd1->spending_num = atof(BroadcastValueString);
					if (NormalEnd1->spending_num<1||NormalEnd1->spending_num>4){
						BroadcastOption = 210901;
						NormalEnd1->spending_num = 0;
					}
					else {
						BroadcastOption = 211000;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 21110: 
					{
					NormalEnd1->event_look[count1_information] = atof(BroadcastValueString);
					if (count1_information == NormalEnd1->num_look-1){
						NormalEnd1->information();
						BroadcastOption = 211200;
					}
					else {
						count1_information ++;
						BroadcastOption = 211100;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 21220:
					{
					int temp_simulation = (int) atof(BroadcastValueString);
					temp_simulation = ((int)(temp_simulation/(NormalEnd1->num_look*2)))*(NormalEnd1->num_look*2);
					NormalEnd2->num_simul = temp_simulation;
					NormalEnd2->getLookSimul();
					cout<<"look_simul="<<NormalEnd2->look_simul<<endl;
					clearString(BroadcastValueString);
					BroadcastOption = 212300 ;
					break;
					}

				case 21230:
					{
					NormalEnd2->mean_Null = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 212400;
					break;
					}

				case 21240:
					{
					NormalEnd2->var_Null = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 212500;
					break;
					}

				case 21250:
					{
					NormalEnd2->mean_Alter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 212600;
					break;
					}

				case 21260:
					{
					NormalEnd2->var_Alter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 212700;
					break;
					}

				case 21270:
					{
					NormalEnd2->overall_alpha = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 212800;
					break;
					}

				case 21280:
					{
					NormalEnd2->overall_beta = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 212900;
					break;
					}

				case 21290: 
					{
					NormalEnd2->spending_num = atof(BroadcastValueString);
					if (NormalEnd2->spending_num<1||NormalEnd2->spending_num>4){
						BroadcastOption = 212901;
						NormalEnd2->spending_num = 0;
					}
					else {
						BroadcastOption = 213000;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 21310: 
					{
					NormalEnd2->event_look[count2_information] = atof(BroadcastValueString);
					if (count2_information == NormalEnd2->num_look-1){
						NormalEnd2->information();
						BroadcastOption = 213200;
					}
					else {
						count2_information ++;
						BroadcastOption = 213100;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 21510: 
					{
					NormalEnd1->corr_ph = atof(BroadcastValueString);
					NormalEnd2->corr_ph = NormalEnd1->corr_ph;
					BroadcastOption = 215200;
					clearString(BroadcastValueString);
					break;
					}

				case 21520: 
					{
					NormalEnd1->Bi_Alpha = atof(BroadcastValueString);
					NormalEnd2->Bi_Alpha = NormalEnd1->Bi_Alpha;
					BroadcastOption = 215300;
					clearString(BroadcastValueString);
					break;
					}

				case 21530: 
					{
					NormalEnd1->Bi_Beta = atof(BroadcastValueString);
					NormalEnd2->Bi_Beta = NormalEnd1->Bi_Beta;
					BroadcastOption = 215400;
					clearString(BroadcastValueString);
					break;
					}

				case 22510: 
					{
					SurvivalEnd1->corr_ph = atof(BroadcastValueString);
					SurvivalEnd2->corr_ph = SurvivalEnd1->corr_ph;
					BroadcastOption = 225200;
					clearString(BroadcastValueString);
					break;
					}

				case 22520: 
					{
					SurvivalEnd1->Bi_Alpha = atof(BroadcastValueString);
					SurvivalEnd2->Bi_Alpha = SurvivalEnd1->Bi_Alpha;
					BroadcastOption = 225300;
					clearString(BroadcastValueString);
					break;
					}

				case 22530: 
					{
					SurvivalEnd1->Bi_Beta = atof(BroadcastValueString);
					SurvivalEnd2->Bi_Beta = SurvivalEnd1->Bi_Beta;
					BroadcastOption = 225400;
					clearString(BroadcastValueString);
					break;
					}

				case 23510: 
					{
					NormalEnd1->corr_ph = atof(BroadcastValueString);
					SurvivalEnd2->corr_ph = NormalEnd1->corr_ph;
					BroadcastOption = 235200;
					clearString(BroadcastValueString);
					break;
					}

				case 23520: 
					{
					NormalEnd1->Bi_Alpha = atof(BroadcastValueString);
					SurvivalEnd2->Bi_Alpha = NormalEnd1->Bi_Alpha;
					BroadcastOption = 235300;
					clearString(BroadcastValueString);
					break;
					}

				case 23530: 
					{
					NormalEnd1->Bi_Beta = atof(BroadcastValueString);
					SurvivalEnd2->Bi_Beta = NormalEnd1->Bi_Beta;
					BroadcastOption = 235400;
					clearString(BroadcastValueString);
					break;
					}

				case 24510: 
					{
					SurvivalEnd1->corr_ph = atof(BroadcastValueString);
					NormalEnd2->corr_ph = SurvivalEnd1->corr_ph;
					BroadcastOption = 245200;
					clearString(BroadcastValueString);
					break;
					}

				case 24520: 
					{
					SurvivalEnd1->Bi_Alpha = atof(BroadcastValueString);
					NormalEnd2->Bi_Alpha = SurvivalEnd1->Bi_Alpha;
					BroadcastOption = 245300;
					clearString(BroadcastValueString);
					break;
					}

				case 24530: 
					{
					SurvivalEnd1->Bi_Beta = atof(BroadcastValueString);
					NormalEnd2->Bi_Beta = SurvivalEnd1->Bi_Beta;
					BroadcastOption = 245400;
					clearString(BroadcastValueString);
					break;
					}

////////////////////////////////////////////////////////////////////////////////////
/*
				case 12020:
					{
						SurvivalEnd1->schon_alpha = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120210;
						break;
					}

				case 12021:
					{
						SurvivalEnd1->schon_beta = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120220;
						break;
					}

				case 12022:
					{
						SurvivalEnd1->schon_delta = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120230;
						break;
					}
			
				case 12023:
					{
						SurvivalEnd1->schon_pe = atof(BroadcastValueString);
						SurvivalEnd1->schon_pc = 1- SurvivalEnd1->schon_pe;
						clearString(BroadcastValueString);
						BroadcastOption = 120240;
						break;
					}

				case 12024:
					{
						SurvivalEnd1->schon_dc = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120250;
						break;
					}
*/
				case 12040:
					{
					int temp_look = (int) atof(BroadcastValueString);
					if (temp_look>LIMIT_N_LOOK || temp_look<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 120401;
					}
					else {
						SurvivalEnd1->num_look = temp_look;
						clearString(BroadcastValueString);
						BroadcastOption = 120410;
					}
					break;
					}

				case 12041:
					{
					int temp_simulation = (int) atof(BroadcastValueString);
					temp_simulation = ((int)(temp_simulation/(SurvivalEnd1->num_look*2)))*(SurvivalEnd1->num_look*2);
					SurvivalEnd1->num_simul = temp_simulation;
					SurvivalEnd1->getLooksimul();
					clearString(BroadcastValueString);
					BroadcastOption = 120420 ;
					break;
					}

				case 12042:
					{
					SurvivalEnd1->alpha = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 120430 ;
					break;
					}

				case 12043:
					{
					SurvivalEnd1->beta = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 120440 ;
					break;
					}

				case 12045: 
					{
					SurvivalEnd1->inform_time[count3_inform] = atof(BroadcastValueString);
					if (count3_inform == SurvivalEnd1->num_look-1){
						//SurvivalEnd1->information();
						BroadcastOption = 120460;
					}
					else {
						count3_inform ++;
						BroadcastOption = 120450;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 12047:
					{
					int temp = (int) atof(BroadcastValueString);
					if (temp> 5 || temp<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 120471;
					}
					else {
						SurvivalEnd1->alphaSpend = temp;
						clearString(BroadcastValueString);
						BroadcastOption = 120480;
					}
					break;
					}

				case 12048:
					{
					int temp = (int) atof(BroadcastValueString);
					if (temp> 5 || temp<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 120481;
					}
					else {
						SurvivalEnd1->betaSpend = temp;
						clearString(BroadcastValueString);
						BroadcastOption = 120490;
					}
					break;
					}

				case 12049:
					{
					SurvivalEnd1->lambdaNull = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 120500 ;
					break;
					}

				case 12050:
					{
					SurvivalEnd1->lambdaAlter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 120510 ;
					break;
					}

				case 12051:
					{
					SurvivalEnd1->entry = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 120520 ;
					break;
					}

				case 12052:
					{
					SurvivalEnd1->followup = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 120530 ;
					break;
					}

				case 12053:
					{
					SurvivalEnd1->lambdadrop = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 120540 ;
					break;
					}

/*
				case 12041:
					{
						SurvivalEnd1->RGS_beta = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120420;
						break;
					}

				case 12042:
					{
						SurvivalEnd1->RGS_delta = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120430;
						break;
					}

				case 12043:
					{
						SurvivalEnd1->RGS_accru = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120440;
						break;
					}

				case 12044:
					{
						SurvivalEnd1->RGS_tau = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120450;
						break;
					}

				case 12045:
					{
						SurvivalEnd1->RGS_lambe = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120460;
						break;
					}

				case 12046:
					{
						SurvivalEnd1->RGS_lambc = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120470;
						break;
					}

				case 12047:
					{
						SurvivalEnd1->RGS_phi = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120480;
						break;
					}

				case 12060:
					{
						SurvivalEnd1->Freed_alpha = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120610;
						break;
					}

				case 12061:
					{
						SurvivalEnd1->Freed_beta = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120620;
						break;
					}

				case 12062:
					{
						SurvivalEnd1->Freed_time = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120630;
						break;
					}

				case 12063:
					{
						SurvivalEnd1->Freed_lambe = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120640;
						break;
					}
			
				case 12064:
					{
						SurvivalEnd1->Freed_lambc = atof(BroadcastValueString);
						clearString(BroadcastValueString);
						BroadcastOption = 120650;
						break;
					}
*/	
//////////////////////////////////////////////////////////////////////////
				case 22040:
					{
					int temp_look = (int) atof(BroadcastValueString);
					if (temp_look>LIMIT_N_LOOK || temp_look<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 220401;
					}
					else {
						SurvivalEnd1->num_look = temp_look;
						SurvivalEnd2->num_look = temp_look;
						clearString(BroadcastValueString);
						BroadcastOption = 220410;
					}
					break;
					}

				case 22041:
					{
					int temp_simulation = (int) atof(BroadcastValueString);
					temp_simulation = ((int)(temp_simulation/(SurvivalEnd1->num_look*2)))*(SurvivalEnd1->num_look*2);
					SurvivalEnd1->num_simul = temp_simulation;
					//SurvivalEnd1->getLooksimul();
					clearString(BroadcastValueString);
					BroadcastOption = 220420 ;
					break;
					}

				case 22042:
					{
					SurvivalEnd1->alpha = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 220430 ;
					break;
					}

				case 22043:
					{
					SurvivalEnd1->beta = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 220440 ;
					break;
					}

				case 22045: 
					{
					SurvivalEnd1->inform_time[count3_inform] = atof(BroadcastValueString);
					if (count3_inform == SurvivalEnd1->num_look-1){
						//SurvivalEnd1->information();
						BroadcastOption = 220460;
					}
					else {
						count3_inform ++;
						BroadcastOption = 220450;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 22047:
					{
					int temp = (int) atof(BroadcastValueString);
					if (temp> 5 || temp<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 220471;
					}
					else {
						SurvivalEnd1->alphaSpend = temp;
						clearString(BroadcastValueString);
						BroadcastOption = 220480;
					}
					break;
					}

				case 22048:
					{
					int temp = (int) atof(BroadcastValueString);
					if (temp> 5 || temp<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 220481;
					}
					else {
						SurvivalEnd1->betaSpend = temp;
						clearString(BroadcastValueString);
						BroadcastOption = 220490;
					}
					break;
					}

				case 22049:
					{
					SurvivalEnd1->lambdaNull = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 220500 ;
					break;
					}

				case 22050:
					{
					SurvivalEnd1->lambdaAlter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 220510 ;
					break;
					}

				case 22051:
					{
					SurvivalEnd1->entry = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 220520 ;
					break;
					}

				case 22052:
					{
					SurvivalEnd1->followup = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 220530 ;
					break;
					}

				case 22053:
					{
					SurvivalEnd1->lambdadrop = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 220540 ;
					break;
					}

/////////////////////////////////////////////////////////////////////
				case 22241:
					{
					int temp_simulation = (int) atof(BroadcastValueString);
					temp_simulation = ((int)(temp_simulation/(SurvivalEnd2->num_look*2)))*(SurvivalEnd2->num_look*2);
					SurvivalEnd2->num_simul = temp_simulation;
					//SurvivalEnd2->getLooksimul();
					clearString(BroadcastValueString);
					BroadcastOption = 222420 ;
					break;
					}

				case 22242:
					{
					SurvivalEnd2->alpha = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 222430 ;
					break;
					}

				case 22243:
					{
					SurvivalEnd2->beta = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 222440 ;
					break;
					}

				case 22245: 
					{
					SurvivalEnd2->inform_time[count4_inform] = atof(BroadcastValueString);
					if (count4_inform == SurvivalEnd2->num_look-1){
						//SurvivalEnd2->information();
						BroadcastOption = 222460;
					}
					else {
						count4_inform ++;
						BroadcastOption = 222450;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 22247:
					{
					int temp = (int) atof(BroadcastValueString);
					if (temp> 5 || temp<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 222471;
					}
					else {
						SurvivalEnd2->alphaSpend = temp;
						clearString(BroadcastValueString);
						BroadcastOption = 222480;
					}
					break;
					}

				case 22248:
					{
					int temp = (int) atof(BroadcastValueString);
					if (temp> 5 || temp<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 222481;
					}
					else {
						SurvivalEnd2->betaSpend = temp;
						clearString(BroadcastValueString);
						BroadcastOption = 222490;
					}
					break;
					}

				case 22249:
					{
					SurvivalEnd2->lambdaNull = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 222500 ;
					break;
					}

				case 22250:
					{
					SurvivalEnd2->lambdaAlter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 222510 ;
					break;
					}

				case 22251:
					{
					SurvivalEnd2->entry = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 222520 ;
					break;
					}

				case 22252:
					{
					SurvivalEnd2->followup = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 222530 ;
					break;
					}

				case 22253:
					{
					SurvivalEnd2->lambdadrop = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 222540 ;
					break;
					}
/////////////////////////////////////////////////////////////////////////////////////////////////
				case 23010:
					{
					int temp_look = (int) atof(BroadcastValueString);
					if (temp_look>LIMIT_N_LOOK || temp_look<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 230101;
					}
					else {
						NormalEnd1->num_look = temp_look;
						SurvivalEnd2->num_look = temp_look;
						clearString(BroadcastValueString);
						BroadcastOption = 230200;
					}
					break;
					}

				case 23020:
					{
					int temp_simulation = (int) atof(BroadcastValueString);
					temp_simulation = ((int)(temp_simulation/(NormalEnd1->num_look*2)))*(NormalEnd1->num_look*2);
					NormalEnd1->num_simul = temp_simulation;
					clearString(BroadcastValueString);
					BroadcastOption = 230300 ;
					break;
					}

				case 23030:
					{
					NormalEnd1->mean_Null = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 230400;
					break;
					}

				case 23040:
					{
					NormalEnd1->var_Null = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 230500;
					break;
					}

				case 23050:
					{
					NormalEnd1->mean_Alter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 230600;
					break;
					}

				case 23060:
					{
					NormalEnd1->var_Alter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 230700;
					break;
					}

				case 23070:
					{
					NormalEnd1->overall_alpha = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 230800;
					break;
					}

				case 23080:
					{
					NormalEnd1->overall_beta = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 230900;
					break;
					}

				case 23090: 
					{
					NormalEnd1->spending_num = atof(BroadcastValueString);
					if (NormalEnd1->spending_num<1||NormalEnd1->spending_num>4){
						BroadcastOption = 230901;
						NormalEnd1->spending_num = 0;
					}
					else {
						BroadcastOption = 231000;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 23110: 
					{
					NormalEnd1->event_look[count1_information] = atof(BroadcastValueString);
					if (count1_information == NormalEnd1->num_look-1){
						NormalEnd1->information();
						BroadcastOption = 231200;
					}
					else {
						count1_information ++;
						BroadcastOption = 231100;
					}
					clearString(BroadcastValueString);
					break;
					}
//////////////////////////////////////////////////////////////////////////////
				case 23241:
					{
					int temp_simulation = (int) atof(BroadcastValueString);
					temp_simulation = ((int)(temp_simulation/(SurvivalEnd2->num_look*2)))*(SurvivalEnd2->num_look*2);
					SurvivalEnd2->num_simul = temp_simulation;
					//SurvivalEnd2->getLooksimul();
					clearString(BroadcastValueString);
					BroadcastOption = 232420 ;
					break;
					}

				case 23242:
					{
					SurvivalEnd2->alpha = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 232430 ;
					break;
					}

				case 23243:
					{
					SurvivalEnd2->beta = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 232440 ;
					break;
					}

				case 23245: 
					{
					SurvivalEnd2->inform_time[count4_inform] = atof(BroadcastValueString);
					if (count4_inform == SurvivalEnd2->num_look-1){
						//SurvivalEnd2->information();
						BroadcastOption = 232460;
					}
					else {
						count4_inform ++;
						BroadcastOption = 232450;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 23247:
					{
					int temp = (int) atof(BroadcastValueString);
					if (temp> 5 || temp<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 232471;
					}
					else {
						SurvivalEnd2->alphaSpend = temp;
						clearString(BroadcastValueString);
						BroadcastOption = 232480;
					}
					break;
					}

				case 23248:
					{
					int temp = (int) atof(BroadcastValueString);
					if (temp> 5 || temp<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 232481;
					}
					else {
						SurvivalEnd2->betaSpend = temp;
						clearString(BroadcastValueString);
						BroadcastOption = 232490;
					}
					break;
					}

				case 23249:
					{
					SurvivalEnd2->lambdaNull = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 232500 ;
					break;
					}

				case 23250:
					{
					SurvivalEnd2->lambdaAlter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 232510 ;
					break;
					}

				case 23251:
					{
					SurvivalEnd2->entry = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 232520 ;
					break;
					}

				case 23252:
					{
					SurvivalEnd2->followup = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 232530 ;
					break;
					}

				case 23253:
					{
					SurvivalEnd2->lambdadrop = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 232540 ;
					break;
					}

//////////////////////////////////////////////////////////
				case 24040:
					{
					int temp_look = (int) atof(BroadcastValueString);
					if (temp_look>LIMIT_N_LOOK || temp_look<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 240401;
					}
					else {
						SurvivalEnd1->num_look = temp_look;
						NormalEnd2->num_look = temp_look;
						clearString(BroadcastValueString);
						BroadcastOption = 240410;
					}
					break;
					}

				case 24041:
					{
					int temp_simulation = (int) atof(BroadcastValueString);
					temp_simulation = ((int)(temp_simulation/(SurvivalEnd1->num_look*2)))*(SurvivalEnd1->num_look*2);
					SurvivalEnd1->num_simul = temp_simulation;
					//SurvivalEnd1->getLooksimul();
					clearString(BroadcastValueString);
					BroadcastOption = 240420 ;
					break;
					}

				case 24042:
					{
					SurvivalEnd1->alpha = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 240430 ;
					break;
					}

				case 24043:
					{
					SurvivalEnd1->beta = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 240440 ;
					break;
					}

				case 24045: 
					{
					SurvivalEnd1->inform_time[count3_inform] = atof(BroadcastValueString);
					if (count3_inform == SurvivalEnd1->num_look-1){
						//SurvivalEnd1->information();
						BroadcastOption = 240460;
					}
					else {
						count3_inform ++;
						BroadcastOption = 240450;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 24047:
					{
					int temp = (int) atof(BroadcastValueString);
					if (temp> 5 || temp<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 240471;
					}
					else {
						SurvivalEnd1->alphaSpend = temp;
						clearString(BroadcastValueString);
						BroadcastOption = 240480;
					}
					break;
					}

				case 24048:
					{
					int temp = (int) atof(BroadcastValueString);
					if (temp> 5 || temp<=0) {
						clearString(BroadcastValueString);
						BroadcastOption = 240481;
					}
					else {
						SurvivalEnd1->betaSpend = temp;
						clearString(BroadcastValueString);
						BroadcastOption = 240490;
					}
					break;
					}

				case 24049:
					{
					SurvivalEnd1->lambdaNull = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 240500 ;
					break;
					}

				case 24050:
					{
					SurvivalEnd1->lambdaAlter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 240510 ;
					break;
					}

				case 24051:
					{
					SurvivalEnd1->entry = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 240520 ;
					break;
					}

				case 24052:
					{
					SurvivalEnd1->followup = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 240530 ;
					break;
					}

				case 24053:
					{
					SurvivalEnd1->lambdadrop = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 240540 ;
					break;
					}
///////////////////////////////////////////////////////////////////////
				case 24220:
					{
					int temp_simulation = (int) atof(BroadcastValueString);
					temp_simulation = ((int)(temp_simulation/(NormalEnd2->num_look*2)))*(NormalEnd2->num_look*2);
					NormalEnd2->num_simul = temp_simulation;
					clearString(BroadcastValueString);
					BroadcastOption = 242300 ;
					break;
					}

				case 24230:
					{
					NormalEnd2->mean_Null = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 242400;
					break;
					}

				case 24240:
					{
					NormalEnd2->var_Null = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 242500;
					break;
					}

				case 24250:
					{
					NormalEnd2->mean_Alter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 242600;
					break;
					}

				case 24260:
					{
					NormalEnd2->var_Alter = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 242700;
					break;
					}

				case 24270:
					{
					NormalEnd2->overall_alpha = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 242800;
					break;
					}

				case 24280:
					{
					NormalEnd2->overall_beta = atof(BroadcastValueString);
					clearString(BroadcastValueString);
					BroadcastOption = 242900;
					break;
					}

				case 24290: 
					{
					NormalEnd2->spending_num = atof(BroadcastValueString);
					if (NormalEnd2->spending_num<1||NormalEnd2->spending_num>4){
						BroadcastOption = 242901;
						NormalEnd2->spending_num = 0;
					}
					else {
						BroadcastOption = 243000;
					}
					clearString(BroadcastValueString);
					break;
					}

				case 24310: 
					{
					NormalEnd2->event_look[count2_information] = atof(BroadcastValueString);
					if (count2_information == NormalEnd2->num_look-1){
						NormalEnd2->information();
						BroadcastOption = 243200;
					}
					else {
						count2_information ++;
						BroadcastOption = 243100;
					}
					clearString(BroadcastValueString);
					break;
					}

				}
				displayBroadcast();
			}
			break;

		}
	}
}


void displayControls(void)
{

  glutSetWindow(control_w);	
  // Make sure we are dealing with the right window
  glClear(GL_COLOR_BUFFER_BIT);

  /////////////////////////
  // "Next" Button
  if (NextActive == TRUE)					// If the mouse is over "Next"
	   glColor3f(1,1,0);					// highlight it, otherwise don't!
  else glColor3f(0,1,0);

  bitmap_output(150, 180, "Next",	
	GLUT_BITMAP_HELVETICA_18);

  /////////////////////////
  // "Return" Button
  if (ReturnActive == TRUE)					// If the mouse is over "Return"
	   glColor3f(1,1,0);					// highlight it, otherwise don't!
  else glColor3f(0,1,0);

  bitmap_output(300, 180, "Return",		
	GLUT_BITMAP_HELVETICA_18);

  /////////////////////////
  // "Calculate" Button
  if (CalculateActive == TRUE)					// If the mouse is over "Calculate"
	   glColor3f(1,1,0);					// highlight it, otherwise don't!
  else glColor3f(0,1,0);

  bitmap_output(450, 180, "Calculate",		// Draw "Load File"
	GLUT_BITMAP_HELVETICA_18);


  /////////////////////////
  // "Exit" Button
  if (ExitActive == TRUE)					// If the mouse is over "Exit"
	  glColor3f(1,1,0);						// highlight it, otherwise don't!
  else glColor3f(0,1,0);

  bitmap_output(620, 180, "Exit",			// Draw "Exit"
    GLUT_BITMAP_HELVETICA_18);


  glFlush();								// Flush the graphics pipe
  glutSwapBuffers();						// Swap buffers
  //glutSetWindow(broadcast_w);
}
//
// ControlMouse: function to determine which choice is clicked,
//      and what to do about it.
//
void ControlMouse(int b, int s, int x, int y)
{

  ///////////////////////////////
  // When "Next" is clicked
  if ((b == GLUT_LEFT_BUTTON) && (NextActive == TRUE)){
	  clearString(BroadcastValueString);
	  if(ActiveQsnIndex == 0){		  
		  //InputBound();
		  BroadcastOption = 100;
		  count1_information = 0;
		  count2_information = 0;
		  count3_inform = 0;
		  count4_inform = 0;
	  }
	  else if (ActiveQsnIndex == 11110){
		  BroadcastOption = 111200;
	  }
	  else if (ActiveQsnIndex == 11140){
		  BroadcastOption = 111500;
	  }
	  else if (ActiveQsnIndex == 12044){
		  BroadcastOption = 120450;
	  }
	  else if (ActiveQsnIndex == 12046){
		  BroadcastOption = 120470;
	  }
	  else if (ActiveQsnIndex == 12100){
		  BroadcastOption = 121100;
	  }

	  else if (ActiveQsnIndex == 21100){
		  BroadcastOption = 211100;
	  }
	  else if (ActiveQsnIndex == 21120){
//		  cout<<"here1"<<endl;
		  NormalEnd1->SizeAdjust();
//		  cout<<"here2"<<endl;
		  BroadcastOption = 212200;
	  }
	  else if (ActiveQsnIndex == 21300){
		  BroadcastOption = 213100;
	  }
	  else if (ActiveQsnIndex == 21320){
		  NormalEnd2->SizeAdjust();
		  BroadcastOption = 215100;
	  }
	  else if (ActiveQsnIndex == 21540){
		  NormalDecisionRule(NormalEnd1, NormalEnd2); 	
		  //Design_Symm_Normal(NormalEnd1, NormalEnd2);
		  BroadcastOption = 216000;
	  }
	  else if (ActiveQsnIndex == 21600){
		  BroadcastOption = 216100;
	  }
	  else if (ActiveQsnIndex == 22044){
		  BroadcastOption = 220450;
	  }
	  else if (ActiveQsnIndex == 22046){
		  BroadcastOption = 220470;
	  }
	  else if (ActiveQsnIndex == 22054){
		  BroadcastOption = 222410;
	  }
	  else if (ActiveQsnIndex == 22244){
		  BroadcastOption = 222450;
	  }
	  else if (ActiveQsnIndex == 22246){
		  BroadcastOption = 222470;
	  }	  
	  else if (ActiveQsnIndex == 22254){
		  BroadcastOption = 225100;
	  }
	  else if (ActiveQsnIndex == 22600){
		  BroadcastOption = 226100;
	  }
	  else if (ActiveQsnIndex == 23100){
		  BroadcastOption = 231100;
	  }
	  else if (ActiveQsnIndex == 23120){
		  BroadcastOption = 232410;
	  }	  
	  else if (ActiveQsnIndex == 23244){
		  BroadcastOption = 232450;
	  }
	  else if (ActiveQsnIndex == 23246){
		  BroadcastOption = 232470;
	  }
	  else if (ActiveQsnIndex == 23254){
		  BroadcastOption = 235100;
	  }
	  else if (ActiveQsnIndex == 23600){
		  BroadcastOption = 236100;
	  }
	  else if (ActiveQsnIndex == 24044){
		  BroadcastOption = 240450;
	  }
	  else if (ActiveQsnIndex == 24046){
		  BroadcastOption = 240470;
	  }
	  else if (ActiveQsnIndex == 24054){
		  BroadcastOption = 242200;
	  }
	  else if (ActiveQsnIndex == 24300){
		  BroadcastOption = 243100;
	  }
	  else if (ActiveQsnIndex == 24320){
		  BroadcastOption = 245100;
	  }
	  else if (ActiveQsnIndex == 24600){
		  BroadcastOption = 246100;
	  }

	  else {
		  BroadcastOption = 111101;
	  }
	  NextActive = FALSE;
	  displayBroadcast();
  }

  ///////////////////////////////////////////////
  // When "Return" is clicked
  if ((b == GLUT_LEFT_BUTTON) && (ReturnActive == TRUE)){
	  clearString(BroadcastValueString);
	  switch(BroadcastOption){
	  case 0:
		  break;
	  case 100:
		  BroadcastOption = 0;
		  break;
	  case 200:
	  case 201:
		  count1_information = 0;
		  count2_information = 0;
		  count3_inform = 0;
		  count4_inform = 0;
		  BroadcastOption = 100;
		  break;
	  case 250:
		  count1_information = 0;
		  count2_information = 0;
		  count3_inform = 0;
		  count4_inform = 0;
		  BroadcastOption = 100;
		  break;
	  case 260:
		  BroadcastOption = 250;
		  break;
	  case 270:
		  BroadcastOption = 260;
		  break;
//////////////////////////////////////////////////////////
	  case 110100:
	  case 110101:
		  BroadcastOption = 200;
		  break;
	  case 110200:
		  BroadcastOption = 110100;
		  break;
	  case 110300:
		  BroadcastOption = 110200;
		  break;
	  case 110400:
		  BroadcastOption = 110300;
		  break;
	  case 110500:
		  BroadcastOption = 110400;
		  break;
	  case 110600:
		  BroadcastOption = 110500;
		  break;
	  case 110700:
		  BroadcastOption = 110600;
		  break;
	  case 110800:
		  BroadcastOption = 110700;
		  break;
	  case 110900:
		  BroadcastOption = 110800;
		  break;
	  case 111000:
		  BroadcastOption = 110900;
		  break;
	  case 111100:
		  BroadcastOption = 111000;
		  break;
	  case 111101:
		  count1_information = 0;
		  count2_information = 0;
		  count3_inform = 0;
		  count4_inform = 0;
		  BroadcastOption = 100;
		  break;
	  case 111200:
		  if(count1_information==0){
			  BroadcastOption = 111100;
		  }
		  else {
			  count1_information--;
			  BroadcastOption = 111200;
		  }
		  break;
	  case 111300:
		  count1_information = 0;
		  BroadcastOption = 111200;
		  break;
/////////////////////////////////////////////
	  case 120100:
		  BroadcastOption = 200;
		  break;
	  case 120200:         // Survival, 'S' type
 		  BroadcastOption = 120100;
		  break;
	  case 120210:
 		  BroadcastOption = 120200;
		  break;
	  case 120220:
 		  BroadcastOption = 120210;
		  break;
	  case 120230:
 		  BroadcastOption = 120220;
		  break;
	  case 120240:
 		  BroadcastOption = 120230;
		  break;
	  case 120250:
 		  BroadcastOption = 120240;
		  break;
	  case 120300:
		  BroadcastOption = 120250;
		  break;

	  case 120400:	//survival_type = 'r'
		  BroadcastOption = 120100;
		  break;
	  case 120410:	
		  BroadcastOption = 120400;
		  break;
	  case 120420:	
		  BroadcastOption = 120410;
		  break;
	  case 120430:	
		  BroadcastOption = 120420;
		  break;
	  case 120440:
		  BroadcastOption = 120430;
		  break;
	  case 120450:	
		  if(count3_inform==0){
			  BroadcastOption = 120440;
		  }
		  else {
			  count3_inform--;
			  BroadcastOption = 120450;
		  }
		  break;
	  case 120460:	
		  count3_inform = 0;
		  BroadcastOption = 120450;
		  break;
	  case 120470:
		  BroadcastOption = 120460;
		  break;
	  case 120480:
 		  BroadcastOption = 120470;
		  break;
	  case 120490:
 		  BroadcastOption = 120480;
		  break;
	  case 120500:
  		  BroadcastOption = 120490;
		  break;
	  case 120510:
  		  BroadcastOption = 120500;
		  break;
	  case 120520:
  		  BroadcastOption = 120510;
		  break;
	  case 120530:
  		  BroadcastOption = 120520;
		  break;
	  case 120540:
  		  BroadcastOption = 120530;
		  break;

/*	  case 120600:	//survival_type = 'F'
   		  BroadcastOption = 120100;
		  break;
	  case 120610:
		  BroadcastOption = 120600;
		  break;
 	  case 120620:
		  BroadcastOption = 120610;
		  break;
	  case 120630:
		  BroadcastOption = 120620;
		  break;
	  case 120640:
		  BroadcastOption = 120630;
		  break;
	  case 120650:
  		  BroadcastOption = 120640;
		  break;
	  case 120700:
  		  BroadcastOption = 120650;
		  break;

	  case 120800: //survival_type = 'L'
  		  BroadcastOption = 120100;
		  break;
*/
/////////////////////////////////////////////
	  case 210100:
		  BroadcastOption = 250;
		  count1_information = 0;
		  count2_information = 0;
		  count3_inform = 0;
		  count4_inform = 0;
		  break;
	  case 210200:
		  BroadcastOption = 210100;
		  break;
	  case 210300:
		  BroadcastOption = 210200;
		  break;
	  case 210400:
		  BroadcastOption = 210300;
		  break;
	  case 210500:
		  BroadcastOption = 210400;
		  break;
	  case 210600:
		  BroadcastOption = 210500;
		  break;
	  case 210700:
		  BroadcastOption = 210600;
		  break;
	  case 210800:
		  BroadcastOption = 210700;
		  break;
	  case 210900:
	  case 210901:
		  BroadcastOption = 210800;
		  break;
	  case 211000:
		  BroadcastOption = 210900;
		  break;
	  case 211100:
		  if(count1_information==0){
			  BroadcastOption = 211000;
		  }
		  else {
			  count1_information--;
			  BroadcastOption = 211100;
		  }
		  break;
	  case 211200:
		  count1_information = 0;
		  BroadcastOption = 211100;
		  break;

	  case 212200:
		  BroadcastOption = 212100;
		  break;
	  case 212300:
		  BroadcastOption = 212200;
		  break;
	  case 212400:
		  BroadcastOption = 212300;
		  break;
	  case 212500:
		  BroadcastOption = 212400;
		  break;
	  case 212600:
		  BroadcastOption = 212500;
		  break;
	  case 212700:
		  BroadcastOption = 212600;
		  break;
	  case 212800:
		  BroadcastOption = 212700;
		  break;
	  case 212900:
	  case 212901:
		  BroadcastOption = 212800;
		  break;
	  case 213000:
		  BroadcastOption = 212900;
		  break;
	  case 213100:
		  if(count2_information==0){
			  BroadcastOption = 213000;
		  }
		  else {
			  count2_information--;
			  BroadcastOption = 213100;
		  }
		  break;
	  case 213200:
		  count2_information = 0;
		  BroadcastOption = 213100;
		  break;
	  case 215100:
		  BroadcastOption = 213200;
		  break;
	  case 215200:
		  BroadcastOption = 215100;
		  break;
	  case 215300:
		  BroadcastOption = 215200;
		  break;
	  case 215400:
		  BroadcastOption = 215300;
		  break;

			
////////////////////////////////////////////////////////////
	  case 220400:	//survival_type = 'r'
		  BroadcastOption = 250;
		  count1_information = 0;
		  count2_information = 0;
		  count3_inform = 0;
		  count4_inform = 0;
		  break;
	  case 220410:	
		  BroadcastOption = 220400;
		  break;
	  case 220420:	
		  BroadcastOption = 220410;
		  break;
	  case 220430:	
		  BroadcastOption = 220420;
		  break;
	  case 220440:
		  BroadcastOption = 220430;
		  break;
	  case 220450:	
		  if(count3_inform==0){
			  BroadcastOption = 220440;
		  }
		  else {
			  count3_inform--;
			  BroadcastOption = 220450;
		  }
		  break;
	  case 220460:	
		  count3_inform = 0;
		  BroadcastOption = 220450;
		  break;
	  case 220470:
		  BroadcastOption = 220460;
		  break;
	  case 220480:
 		  BroadcastOption = 220470;
		  break;
	  case 220490:
 		  BroadcastOption = 220480;
		  break;
	  case 220500:
  		  BroadcastOption = 220490;
		  break;
	  case 220510:
  		  BroadcastOption = 220500;
		  break;
	  case 220520:
  		  BroadcastOption = 220510;
		  break;
	  case 220530:
  		  BroadcastOption = 220520;
		  break;
	  case 220540:
  		  BroadcastOption = 220530;
		  break;

	  case 222410:
		  BroadcastOption = 220540;
		  break;
	  case 222420:	
		  BroadcastOption = 222410;
		  break;
	  case 222430:	
		  BroadcastOption = 222420;
		  break;
	  case 222440:
		  BroadcastOption = 222430;
		  break;
	  case 222450:	
		  if(count4_inform==0){
			  BroadcastOption = 222440;
		  }
		  else {
			  count4_inform--;
			  BroadcastOption = 222450;
		  }
		  break;
	  case 222460:	
		  count4_inform = 0;
		  BroadcastOption = 222450;
		  break;
	  case 222470:
		  BroadcastOption = 222460;
		  break;
	  case 222480:
 		  BroadcastOption = 222470;
		  break;
	  case 222490:
 		  BroadcastOption = 222480;
		  break;
	  case 222500:
  		  BroadcastOption = 222490;
		  break;
	  case 222510:
  		  BroadcastOption = 222500;
		  break;
	  case 222520:
  		  BroadcastOption = 222510;
		  break;
	  case 222530:
  		  BroadcastOption = 222520;
		  break;
	  case 222540:
  		  BroadcastOption = 222530;
		  break;

	  case 225100:
		  BroadcastOption = 222540;
		  break;
	  case 225200:
		  BroadcastOption = 225100;
		  break;
	  case 225300:
		  BroadcastOption = 225200;
		  break;
	  case 225400:
		  BroadcastOption = 225300;
		  break;

/////////////////////////////////////////////
	  case 230100:
		  BroadcastOption = 250;
		  count1_information = 0;
		  count2_information = 0;
		  count3_inform = 0;
		  count4_inform = 0;
		  break;
	  case 230200:
		  BroadcastOption = 230100;
		  break;
	  case 230300:
		  BroadcastOption = 230200;
		  break;
	  case 230400:
		  BroadcastOption = 230300;
		  break;
	  case 230500:
		  BroadcastOption = 230400;
		  break;
	  case 230600:
		  BroadcastOption = 230500;
		  break;
	  case 230700:
		  BroadcastOption = 230600;
		  break;
	  case 230800:
		  BroadcastOption = 230700;
		  break;
	  case 230900:
	  case 230901:
		  BroadcastOption = 230800;
		  break;
	  case 231000:
		  BroadcastOption = 230900;
		  break;
	  case 231100:
		  if(count1_information==0){
			  BroadcastOption = 231000;
		  }
		  else {
			  count1_information--;
			  BroadcastOption = 231100;
		  }
		  break;
	  case 231200:
		  count1_information = 0;
		  BroadcastOption = 231100;
		  break;

	  case 232410:
		  BroadcastOption = 231200;
		  break;
	  case 232420:	
		  BroadcastOption = 232410;
		  break;
	  case 232430:	
		  BroadcastOption = 232420;
		  break;
	  case 232440:
		  BroadcastOption = 232430;
		  break;
	  case 232450:	
		  if(count4_inform==0){
			  BroadcastOption = 232440;
		  }
		  else {
			  count4_inform--;
			  BroadcastOption = 232450;
		  }
		  break;
	  case 232460:	
		  count4_inform = 0;
		  BroadcastOption = 232450;
		  break;
	  case 232470:
		  BroadcastOption = 232460;
		  break;
	  case 232480:
 		  BroadcastOption = 232470;
		  break;
	  case 232490:
 		  BroadcastOption = 232480;
		  break;
	  case 232500:
  		  BroadcastOption = 232490;
		  break;
	  case 232510:
  		  BroadcastOption = 232500;
		  break;
	  case 232520:
  		  BroadcastOption = 232510;
		  break;
	  case 232530:
  		  BroadcastOption = 232520;
		  break;
	  case 232540:
  		  BroadcastOption = 232530;
		  break;

	  case 235100:
		  BroadcastOption = 232540;
		  break;
	  case 235200:
		  BroadcastOption = 235100;
		  break;
	  case 235300:
		  BroadcastOption = 235200;
		  break;
	  case 235400:
		  BroadcastOption = 235300;
		  break;
////////////////////////////////////////////////////////////////////////
	  case 240400:
		  BroadcastOption = 250;
		  count1_information = 0;
		  count2_information = 0;
		  count3_inform = 0;
		  count4_inform = 0;
		  break;
	  case 240410:	
		  BroadcastOption = 240400;
		  break;
	  case 240420:	
		  BroadcastOption = 240410;
		  break;
	  case 240430:	
		  BroadcastOption = 240420;
		  break;
	  case 240440:
		  BroadcastOption = 240430;
		  break;
	  case 240450:	
		  if(count3_inform==0){
			  BroadcastOption = 240440;
		  }
		  else {
			  count3_inform--;
			  BroadcastOption = 240450;
		  }
		  break;
	  case 240460:	
		  count3_inform = 0;
		  BroadcastOption = 240450;
		  break;
	  case 240470:
		  BroadcastOption = 240460;
		  break;
	  case 240480:
 		  BroadcastOption = 240470;
		  break;
	  case 240490:
 		  BroadcastOption = 240480;
		  break;
	  case 240500:
  		  BroadcastOption = 240490;
		  break;
	  case 240510:
  		  BroadcastOption = 240500;
		  break;
	  case 240520:
  		  BroadcastOption = 240510;
		  break;
	  case 240530:
  		  BroadcastOption = 240520;
		  break;
	  case 240540:
  		  BroadcastOption = 240530;
		  break;

	  case 242200:
		  BroadcastOption = 240540;
		  break;
	  case 242300:
		  BroadcastOption = 242200;
		  break;
	  case 242400:
		  BroadcastOption = 242300;
		  break;
	  case 242500:
		  BroadcastOption = 242400;
		  break;
	  case 242600:
		  BroadcastOption = 242500;
		  break;
	  case 242700:
		  BroadcastOption = 242600;
		  break;
	  case 242800:
		  BroadcastOption = 242700;
		  break;
	  case 242900:
	  case 242901:
		  BroadcastOption = 242800;
		  break;
	  case 243000:
		  BroadcastOption = 242900;
		  break;
	  case 243100:
		  if(count2_information==0){
			  BroadcastOption = 243000;
		  }
		  else {
			  count2_information--;
			  BroadcastOption = 243100;
		  }
		  break;
	  case 243200:
		  count2_information = 0;
		  BroadcastOption = 243100;
		  break;
		
	  case 245100:
		  BroadcastOption = 243200;
		  break;
	  case 245200:
		  BroadcastOption = 245100;
		  break;
	  case 245300:
		  BroadcastOption = 245200;
		  break;
	  case 245400:
		  BroadcastOption = 245300;
		  break;

//////////////////////////////////////////////////////
	  case 999999999:
		  stringcounter=0;
		  count1_information = 0;
		  count2_information = 0;
		  count3_inform = 0;
		  count4_inform = 0;
		  BroadcastOption = 100;
		  break;
	  }

	  ReturnActive = FALSE;
	  displayBroadcast();
  }

  ///////////////////////////////////////////////
  // When "Calculate" is clicked
  if ((b == GLUT_LEFT_BUTTON) && (CalculateActive == TRUE)){
	  if(ActiveQsnIndex == 11100){
		  result_OneStageNormal = NormalEnd1->one_stage_normal();
		  BroadcastOption = 111100;
	  }	  
	  else if (ActiveQsnIndex == 11130){
		  NormalEnd1->SizeAdjust();
		  cout<<"SizeAdjust() Done Successfully"<<endl;
		  BroadcastOption = 111400;
	  }
	  else if (ActiveQsnIndex == 12054){
		  cout<<"Here is the result for Survival Size Calculation:\t";
		  cout<<SurvivalEnd1->Choice()<<endl;
		  BroadcastOption = 121000;
	  }	
	  else if (ActiveQsnIndex == 22540){
		  TwoSurvival();					
		  BroadcastOption = 226000;
	  }
	  else if (ActiveQsnIndex == 23540){
		//normal then sursival	
		  NorSurvival(); 	
		  BroadcastOption = 236000;
	  }
	  else if (ActiveQsnIndex == 24540){
		// Survival then Normal
		  SurNormal();

		  BroadcastOption = 246000;
	  }

/*	  else if(ActiveQsnIndex == 12025){
		  SurvivalEnd1->schonfeld();
		  BroadcastOption = 120300;
	  }
	  else if(ActiveQsnIndex == 12048){
		  SurvivalEnd1->RGS();
		  BroadcastOption = 120500;
	  }
	  else if(ActiveQsnIndex == 12065){
		  SurvivalEnd1->Freedman();
		  BroadcastOption = 120700;
	  }
*/	  else {
		  BroadcastOption = 111101;
	  }
	  CalculateActive = FALSE;
	  displayBroadcast();
  }

  ///////////////////////////////
  //  When "Exit" is clicked
  if ((b == GLUT_LEFT_BUTTON) && (ExitActive == TRUE)){
		exit(0);
  }
}

void ControlMousePassive(int x, int y)
{

	/////////////////////////////////
	// Mouse over "Next File"
	if ((x >= 140 && x <= 190) && (y >= 30 && y <= 70)){
		if (NextActive == FALSE) {
			NextActive = TRUE;
			displayControls();
		}
	}

	else {
		if (NextActive == TRUE){
			NextActive = FALSE;
			displayControls();
		}
	}

	/////////////////////////////////
	// Mouse over "Return File"
	if ((x >= 290 && x <= 350) && (y >= 30 && y <= 70)){
		if (ReturnActive == FALSE) {
			ReturnActive = TRUE;
			displayControls();
		}
	}

	else {
		if (ReturnActive == TRUE){
			ReturnActive = FALSE;
			displayControls();
		}
	}

	/////////////////////////////////
	// Mouse over "Calculate File"
	if ((x >= 435 && x <= 525) && (y >= 30 && y <= 70)){
		if (CalculateActive == FALSE) {
			CalculateActive = TRUE;
			displayControls();
		}
	}

	else {
		if (CalculateActive == TRUE){
			CalculateActive = FALSE;
			displayControls();
		}
	}

	/////////////////////////////////
	// Mouse over "Exit File"
	if ((x >= 600 && x <= 650) && (y >= 30 && y <= 70)){
		if (ExitActive == FALSE) {
			ExitActive = TRUE;
			displayControls();
		}
	}

	else {
		if (ExitActive == TRUE){
			ExitActive = FALSE;
			displayControls();
		}
	}
}



//////////////////////////////////////////

void ftoa(float f)
{
	clearString(BroadcastString);
	sprintf(BroadcastString, "%f\0", f);
}

void ftoa_a(float f)
{
	clearString(BroadcastString);
	sprintf(BroadcastString, "%8.4f\0", f);
}

void itoa(int i)
{
	clearString(BroadcastString);
	sprintf(BroadcastString, "%d\0", i);
}


//////////////////////////
//  Trim String for BroadcastValueString
char* trimString(char *str1)
{
	int length = strlen(str1);
	int s=0;
	while (str1[s]==' ') {
		s++;
	}
	char *str2 = new char[256];
	int i=0;
	while(s+i<length){
		str2[i]=str1[s+i];
		i++;
	}
	str2[i]='\0';

	return str2;
}
	/////////////////////////////////////////////////

















// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
////   Below is the code for two Normal Endpoint. 
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


// Next, we do the COUNTING:

// Function 1: just count the probability in each region.
//             We will not adjust c or sample size in the counting function.

/// Counting of Probabilities in each region.
//  Input:  The critical boundaries
//          The simulated matrix, numoflook*look_simul
//  Output: Probability in each region. (an array 1*4)

///////  Case 1: the symmetric decision rule:               ///////
///////  At the k look, we have the following possibilities:   ////

//  Accept H00,  
//  Accept H01
//  Accept H10
//  Accept H11
//  Continue sampling.

//  So for each look, we count the count in these four cases seperately.
//  The boundary1 is the array with critical boundaries for the first endpoint.
//  The boundary2                                               second
//  The simul_matrix1 is the simulated matrix for endpoint 1, with size looknum*simul_look
//  The simul_matrix2                             endpoint 2,


double *symm_prob_count(double *boundary1, double *simul_matrix1, 
						double *boundary2, double *simul_matrix2, EndNormal * end1)
{
	double *upperbound1, *lowerbound1;
	double *upperbound2, *lowerbound2;
	double *count;   // The matrix we use to count the number in each region.
	int i, j, k, l, m;
	double *workarray1, *workarray2;  // each time, we work on a row. for two endpoints
	int indicator;      // better use a Boolean variable


	int looknum= end1->num_look;   //!! ATTENTION PLEASE!!
	int simul_look= end1->look_simul;   // These two: from the EndNormal type endpoint[0] and endpoint[1]


	count=new double[9];  // Here we count all 9 possible conditions.  
	workarray1=new double[looknum];
	workarray2=new double[looknum];

	upperbound1=new double[looknum];
	lowerbound1=new double[looknum];
	upperbound2=new double[looknum];
	lowerbound2=new double[looknum];


	for(m=0; m<9; m++)
		count[m]=0.0;

	for(i=0; i< looknum; i++)
		{
			lowerbound1[i]=boundary1[2*i];
			upperbound1[i]=boundary1[2*i+1];
			lowerbound2[i]=boundary2[2*i];
			upperbound2[i]=boundary2[2*i+1];
		}	// Initialize the boundaries.

	
	// we now check the simul_matrix1 (End1) and simul_matrix2 (End2) numerically:
//	cout<<"The following is the check of simul_matrix1 and simul_matrix2:"<<endl;
	double *checkA1, *checkA2;
	double *meanA1, *varA1;
	double *corrA1;
	int ch1, ch2;

	checkA1=new double[simul_look];
	checkA2=new double[simul_look];
	meanA1=new double[looknum];
	varA1=new double[looknum];
	corrA1=new double[looknum*looknum];


	for(ch1=0; ch1<looknum; ch1++) {
		meanA1[ch1]=0.0;
		varA1[ch1]=0.0;
		for( ch2=0; ch2<simul_look; ch2++) {
			checkA1[ch2]=simul_matrix1[ch2*looknum+ch1];
			meanA1[ch1]=meanA1[ch1]+checkA1[ch2];
		}
		meanA1[ch1]=meanA1[ch1]/simul_look;
		for( ch2=0; ch2<simul_look; ch2++) {
			checkA1[ch2]=checkA1[ch2]-meanA1[ch1];
			varA1[ch1]=varA1[ch1]+checkA1[ch2]*checkA1[ch2];
			}
		varA1[ch1]=varA1[ch1]/simul_look;
	}
	

	//  THE BIG LOOP
	for(j=0; j< simul_look; j++)
		{
			for(i=0; i< looknum; i++)  // Initialize the working array.
				{
					workarray1[i]=simul_matrix1[j*looknum+i];
					workarray2[i]=simul_matrix2[j*looknum+i];
				}    //	We only need the absolute value for the symmetric case  

			indicator=0; // while indicator is False
			k=0;         // start from the first look 
			while(indicator !=1)
				{
					//case 1, accept H00
					if( (indicator!=1) && (absd(workarray1[k])<lowerbound1[k]) && (absd(workarray2[k])<lowerbound2[k]) )
						{
							count[0]=count[0]+1;
							indicator=1;
						}

					//case 2, accept H01
					//subcase 2.1, accept H0+
					if( (indicator!=1) && (absd(workarray1[k])<lowerbound1[k]) && (workarray2[k]>upperbound2[k]) )
						{
							count[1]=count[1]+1;
							indicator=1;
						}
					//subcase 2.2, accept H0-
					if( (absd(workarray1[k])<lowerbound1[k]) && (workarray2[k]<(-upperbound2[k])))
						{
							count[2]=count[2]+1;
							indicator=1;
						}

					//case 3, accept H10
					//subcase 3.1, accept H+0
					if( (workarray1[k]>upperbound1[k]) && (absd(workarray2[k])<lowerbound2[k]) )
						{
							count[3]=count[3]+1;
							indicator=1;
						}
					//subcase 3.2, accept H-0
					if( (workarray1[k]<(-upperbound1[k])) && (absd(workarray2[k])<lowerbound2[k] ) )
						{
							count[4]=count[4]+1;
							indicator=1;
						}

					//case 4, accept H11
					//subcase 4.1, accept H++
					if( (workarray1[k]>upperbound1[k]) && (workarray2[k]>upperbound2[k]) )
						{
							count[5]=count[5]+1;
							indicator=1;
						}
					//subcase 4.2, accept H+-
					if( (workarray1[k]>upperbound1[k]) && (workarray2[k]<(-upperbound2[k])) )
						{
							count[6]=count[6]+1;
							indicator=1;
						}
					//subcase 4.3, accept H-+
					if( (workarray1[k]<(-upperbound1[k]) ) && (workarray2[k]>upperbound2[k]) )
						{
							count[7]=count[7]+1;
							indicator=1;
						}
					//subcase 4.4, accept H--
					if( (workarray1[k]<(-upperbound1[k])) && (workarray2[k]<(-upperbound2[k])) )
						{
							count[8]=count[8]+1;
							indicator=1;
						}

					//if in the continuity region, then move to the next one.
					k=k+1;
				}


	} // The loop ending here runs first to the simul_look elements.
	  // Each element consists of two endpoints.


	for(l=0; l<9; l++)
		count[l]=count[l]/simul_look;  //change from count to probability
	return count;
}




// 
//	The Decision Function:
//

void NormalDecisionRule(EndNormal *end1, EndNormal *end2)
{
	if(end1->rule_decision==1){ // in case of hard decision
		Design_Symm_Normal(end1, end2);
	}
	if(end1->rule_decision==0){ // in case of soft decision
		Design_NonSymm_Normal(end1, end2);
	}

}




/////////////////////////////////////////////
// Case 1: Design of Symmetric Case (which allows for hard decision only.)

// Next is the design stage of the Two endpoint case:
/* We need to do the following:
               1. generating the Null and Alternative and use them as input for previous two counting program
			   since each time, we need to consider only one combinations (Null or Alter)
			   the input will be two look_simul*num_look matrix. one for each endpoints.
			   2. adjust the constant c, to get the corresponding global alpha.
			      Here, we consider the Null ONLY
			   3. adjust the sample size to get the corresponding global beta.
				  Here, we consider the Alternative ONLY
				  */
///      Input: we should have complete information of two endpoint seperately now.

///      Get the traget Type I and type II error from somewhere of the interface
///      and the overall Bi_Alpha and Bi_Beta, double type


void Design_Symm_Normal(EndNormal * end1, EndNormal * end2 )
{
	int con1;
	// the check procedure for two survival case:

	int look_num, simul_look;
	look_num= end1->num_look;
	simul_look= end1->look_simul;

	double Bi_Alpha = end1->Bi_Alpha;
	double Bi_Beta = end1->Bi_Beta;

	int numofAlter=9;			//number of alternatives.
	int numofRegion=9;           // To avoid mis-counting the regions.
	double c_lower, c_mid, c_upper;  // The constant we are looking for.
	double alpha_upper, alpha_mid, alpha_lower; // the working alpha corresponding to c_lower....	
	
	double *simul1, *simul2;			 // Two endpoint
	double *simulNull1, *simulNull2;	 // Two simulated Null.
	double *simulAlter1, *simulAlter2;   //simulated alternative for each endpoints
	simul1=new double[2*look_num*simul_look];
	simul2=new double[2*look_num*simul_look];
	simulNull1=new double[look_num*simul_look];
	simulNull2=new double[look_num*simul_look];
	simulAlter1=new double[look_num*simul_look];
	simulAlter2=new double[look_num*simul_look];

	//Initialize simulated matrix: in case of no correlation ONLY

	simul1=end1->NullAlterGenerator1();
	simul2=end2->NullAlterGenerator1();

	int ini1, ini2;
	for(ini1=0; ini1<simul_look; ini1++){
		for(ini2=0; ini2<look_num; ini2++) {
			simulNull1[ini1*look_num+ini2]=simul1[ini1*look_num+2*ini2];
			simulNull2[ini1*look_num+ini2]=simul2[ini1*look_num+2*ini2];
			simulAlter1[ini1*look_num+ini2]=simul1[ini1*look_num+2*ini2+1];
			simulAlter2[ini1*look_num+ini2]=simul2[ini1*look_num+2*ini2+1];
		}
	}


	double *AlterMean1 = new double[simul_look];
	double *AlterMean2 = new double[simul_look];
	// For each sample size, we adjust the constant c, to satisfy the alpha.
	// Then calculate the beta for each possible Alternative. Get the maximal.
	
	int worksize;			// working sample size

	double betaFunc=0.0;		// Type two error. 
	double alphaFunc=0.0;      // Type one error. 

	double *betaWork;       // Work Beta function; since we have multiple alternative
	double *workProb;     // The working probability array.
	double *workProbNull;
	double *workProbAlter;
	double *workProbAlpha;
	betaWork=new double[numofAlter];            // num of alternatives.
	workProb=new double[numofRegion ];
	workProbNull=new double[numofRegion];      //corresponding to nine cases from previous function
	workProbAlter=new double[numofRegion];
	workProbAlpha=new double[numofRegion];

	

	double *workBoundary1, *workBoundary2;
	workBoundary1=new double[look_num*2];
	workBoundary2=new double[look_num*2];

	int i, j, k,  m;

	// Initialize boundary for each endpoints
	for(i=0; i<2*look_num; i++) {
		workBoundary1[i]=end1->boundary[i];
		workBoundary2[i]=end2->boundary[i];
	}

	worksize=maxm(end1->sample_size, end2->sample_size);

	//while we can not satisfy the beta requirement


	int sizeup, sizelow, sizemiddle;
	sizemiddle=worksize;

	int signcontinue=0;

	int c_midsign=0;

	int jj=0;
	double *checkbeta;
	checkbeta=new double[10000];
	int stopsign=0;

	while( stopsign==0 )  {
		//Calculate for the alpha:
		

		for(i=0; i<look_num; i++){
			AlterMean1[i]=end1->mean_Alter*sqrt(worksize*end1->inform_time[i]);
			AlterMean2[i]=end2->mean_Alter*sqrt(worksize*end2->inform_time[i]);
		}

		// the loop searching for constant c:
		// if c_midsign=0, then search; else do not do it:
		if( c_midsign==0 ) {
			workProbNull=symm_prob_count(workBoundary1, simulNull1,
										 workBoundary2, simulNull2, end1);

			alphaFunc=1-workProbNull[0];  // Outside of the H00 Region
		
			c_mid=1.0;
		
			// Search for c_lower and c_upper first:
			c_lower=c_mid;
			c_upper=c_mid;

			alpha_lower=alphaFunc;
			alpha_upper=alphaFunc;

			double *meantemp;
			int t1, t2;
			meantemp=new double[end1->num_look];
			for(t1=0; t1<end1->num_look; t1++){
				meantemp[t1]=0;
				for(t2=0; t2<end1->look_simul; t2++){
					meantemp[t1]=meantemp[t1]+simulNull1[t2*end1->num_look+t1];
				}
				meantemp[t1]=meantemp[t1]/end1->look_simul;
			}

	//		mean of simulNull1 is 0.

			while( alpha_upper-Bi_Alpha>0.001 ) {

				c_upper=1.2*c_upper;
				for(m=0; m<look_num; m++) {
					workBoundary1[m]=end1->boundary[m]*c_upper;
					workBoundary2[m]=end2->boundary[m]*c_upper;
				}
			
				workProbAlpha=symm_prob_count(workBoundary1, simulNull1, workBoundary2, simulNull2, end1);
				alpha_upper=1-workProbAlpha[0];

			}


			while( alpha_lower-Bi_Alpha<0.001 ){
				c_lower=c_lower/1.2;
				for(m=0; m<2*look_num; m++)	{
					workBoundary1[m]=end1->boundary[m]*c_lower;
					workBoundary2[m]=end2->boundary[m]*c_lower;
				}
				
				workProbAlpha=symm_prob_count(workBoundary1, simulNull1, workBoundary2, simulNull2, end1);
				alpha_lower=1-workProbAlpha[0];

			}
		
			// First calculation of c_mid

			c_mid=(c_lower+c_upper)/2;
			for(m=0; m<2*look_num; m++)	{
				workBoundary1[m]=end1->boundary[m]*c_mid;
				workBoundary2[m]=end2->boundary[m]*c_mid;
			}
				
			workProbAlpha=symm_prob_count(workBoundary1, simulNull1, workBoundary2, simulNull2, end1);
			alphaFunc=1-workProbAlpha[0];

			while( absd(alphaFunc-end1->Bi_Alpha) > 0.002 ) {
		
				if(alphaFunc < end1->Bi_Alpha){
					c_upper=c_mid;
				}

				if(alphaFunc > end1->Bi_Alpha) {
					c_lower=c_mid;
				}
			
				c_mid=(c_lower+c_upper)/2;
				for(m=0; m<2*look_num; m++){
					workBoundary1[m]=end1->boundary[m]*c_mid;
					workBoundary2[m]=end2->boundary[m]*c_mid;
				}	

				workProbAlpha=symm_prob_count(workBoundary1, simulNull1, workBoundary2, simulNull2, end1);
			
				alphaFunc=1-workProbAlpha[0];

			}

			c_midsign=1;
		}
		else if(c_midsign==1)
			c_mid=c_mid;

		double *alterworkbound1, *alterworkbound2;
		alterworkbound1=new double[2*look_num];
		alterworkbound2=new double[2*look_num];

		for(m=0; m<2*look_num;m++) {
			alterworkbound1[m]=end1->boundary[m]*c_mid;
			alterworkbound2[m]=end2->boundary[m]*c_mid;
		}

	for(j=0; j<numofAlter; j++)
		betaWork[j]=0;

	// Calculate for the beta, Nwe version: 8/19/2003
	// case 0: alternative H-0
	if( end1->ctrl_ind[0]==1 ){
		for(j=0; j<simul_look; j++)	
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]-AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k];
					}
			}

		workProbAlter=symm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[0]=1-workProbAlter[4];
	}

	// case 1: alternative H+0
	if( end1->ctrl_ind[1]==1 ){
		for(j=0; j<simul_look; j++)	
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]+AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k];
					}
			}

		workProbAlter=symm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[1]=1-workProbAlter[3];
	}
	

	// case 2: alternative H0+
	if( end1->ctrl_ind[2]==1 ){
		for(j=0; j<simul_look; j++)	
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]+AlterMean2[k];
					}
			}

		workProbAlter=symm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[2]=1-workProbAlter[1];
	}

	// case 3: alternative H0-
	if( end1->ctrl_ind[3]==1 ){
		for(j=0; j<simul_look; j++)	
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]-AlterMean2[k];
					}
			}

		workProbAlter=symm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[3]=1-workProbAlter[2];
	}
	
	// case 4: alternative H-+
	if( end1->ctrl_ind[4]==1 ){
		for(j=0; j<simul_look; j++)	
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]-AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]+AlterMean2[k];
					}
			}

		workProbAlter=symm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[4]=1-workProbAlter[7];
	}

	// case 5: alternative H++
	if( end1->ctrl_ind[5]==1 ){
		for(j=0; j<simul_look; j++)	
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]+AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]+AlterMean2[k];
					}
			}

		workProbAlter=symm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[5]=1-workProbAlter[5];
	}

	// case 6: alternative H--
	if( end1->ctrl_ind[6]==1 ){
		for(j=0; j<simul_look; j++)	
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]-AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]-AlterMean2[k];
					}
			}

		workProbAlter=symm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[6]=1-workProbAlter[8];
	}

	// case 7: alternative H+-
	if( end1->ctrl_ind[6]==1 ){
		for(j=0; j<simul_look; j++)	
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]+AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]-AlterMean2[k];
					}
			}

		workProbAlter=symm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[7]=1-workProbAlter[6];
	}

	betaFunc=betaWork[0];
	for(j=0; j<numofAlter; j++)
		if( betaFunc<betaWork[j] )
			betaFunc=betaWork[j];

	checkbeta[jj]=betaFunc;

	double temp1;
	
	if(jj>0)
		temp1=(checkbeta[jj]-Bi_Beta)*(checkbeta[jj-1]-Bi_Beta);
	else 
		temp1=1;
	jj=jj+1;

	if( betaFunc > Bi_Beta) {
		if( temp1 <0)
			stopsign=1;
		worksize=worksize+1;
	}
	if(betaFunc < Bi_Beta) {
		if(temp1 <0)
			stopsign=1;
		worksize=worksize-1;
	}
	}

	end1->sample_size=worksize;
	end2->sample_size=worksize;

	for(i=0; i<look_num; i++){
		end1->lower_bound[i]=end1->lower_bound[i]*c_mid;
		end2->lower_bound[i]=end2->lower_bound[i]*c_mid;
		end1->upper_bound[i]=end1->upper_bound[i]*c_mid;
		end2->upper_bound[i]=end2->upper_bound[i]*c_mid;
	}

	for(i=0; i<2*look_num; i++){
		end1->boundary[i]=end1->boundary[i]*c_mid;
		end2->boundary[i]=end2->boundary[i]*c_mid;
	}

	cout<<"samplesize"<<"\t"<<worksize<<endl;
//	cin>>con1;
}







// Next, we count the non-symmetric case, which allows for soft decision for the second endpoint.
// 


///////  Case 2: the non-symmetric decision rule:

//Input: The Critical Boundaries
//       The simulated matrix
//Output: Probability in each region. (an array 1*6)
///////  At the k look, we have the folloing possibilities:
//  Accept H -*,  Region 1
//  Accept H +*,  Region 2
//  Accept H 0+,  Region 3
//  Accept H 0-,  Region 4
//  Accept H 00,  Region 5
//  Accept H (-)- Region 6




double *nonsymm_prob_count(double *boundary1, double *simul_matrix1, 
						double *boundary2, double *simul_matrix2, EndNormal * end1)
{
	double *upperbound1, *lowerbound1;
	double *upperbound2, *lowerbound2;
	double *count;   // The matrix we use to count the number in each region.
	int i, j, k, l, m;
	double *workarray1, *workarray2;  // each time, we work on a row. for two endpoints
	int indicator;      // better use a Boolean variable


	int looknum= end1->num_look;   //!! ATTENTION PLEASE!!
	int simul_look= end1->look_simul;   // These two: from the EndNormal type endpoint[0] and endpoint[1]

	int countregion=6; 

	count=new double[countregion];  // Here we count all 6 possible conditions.  
	workarray1=new double[looknum];
	workarray2=new double[looknum];

	upperbound1=new double[looknum];
	lowerbound1=new double[looknum];
	upperbound2=new double[looknum];
	lowerbound2=new double[looknum];


	for(m=0; m<countregion; m++)
		count[m]=0.0;

	for(i=0; i< looknum; i++)
		{
			lowerbound1[i]=boundary1[2*i];
			upperbound1[i]=boundary1[2*i+1];
			lowerbound2[i]=boundary2[2*i];
			upperbound2[i]=boundary2[2*i+1];
		}	// Initialize the boundaries.

	
	// we now check the simul_matrix1 (End1) and simul_matrix2 (End2) numerically:
	double *checkA1, *checkA2;
	double *meanA1, *varA1;
	double *corrA1;
	int ch1, ch2;

	checkA1=new double[simul_look];
	checkA2=new double[simul_look];
	meanA1=new double[looknum];
	varA1=new double[looknum];
	corrA1=new double[looknum*looknum];


	for(ch1=0; ch1<looknum; ch1++) {
		meanA1[ch1]=0.0;
		varA1[ch1]=0.0;
		for( ch2=0; ch2<simul_look; ch2++) {
			checkA1[ch2]=simul_matrix1[ch2*looknum+ch1];
			meanA1[ch1]=meanA1[ch1]+checkA1[ch2];
		}
		meanA1[ch1]=meanA1[ch1]/simul_look;
		for( ch2=0; ch2<simul_look; ch2++) {
			checkA1[ch2]=checkA1[ch2]-meanA1[ch1];
			varA1[ch1]=varA1[ch1]+checkA1[ch2]*checkA1[ch2];
			}
		varA1[ch1]=varA1[ch1]/simul_look;
	}
	

	//  THE BIG LOOP
	for(j=0; j< simul_look; j++)
		{
			for(i=0; i< looknum; i++)  // Initialize the working array.
				{
					workarray1[i]=simul_matrix1[j*looknum+i];
					workarray2[i]=simul_matrix2[j*looknum+i];
				}    //	We only need the absolute value for the symmetric case  

			indicator=0; // while indicator is False
			k=0;         // start from the first look 
			while(indicator !=1)
				{
					//case 1, accept H - *
					if( (indicator!=1) && (workarray1[k]<-upperbound1[k]) )
						{
							count[0]=count[0]+1;
							indicator=1;
						}

					//case 2, accept H + *
					if( (indicator!=1) && (workarray1[k]>upperbound1[k]) )
						{
							count[1]=count[1]+1;
							indicator=1;
						}

					//case 3, accept H 0 +
					if( (indicator!=1) && (absd(workarray1[k])<lowerbound1[k]) && (workarray2[k]>upperbound2[k]) )
						{
							count[2]=count[2]+1;
							indicator=1;
						}

					//case 4, accept H 0 -
					if( (indicator!=1) && (absd(workarray1[k])<lowerbound1[k]) && (workarray2[k]<-upperbound2[k]) )
						{
							count[3]=count[3]+1;
							indicator=1;
						}
				
					//case 5, accept H 0 0
					if( (indicator!=1) && (absd(workarray1[k])<lowerbound1[k]) && (absd(workarray2[k])<lowerbound2[k]) )
						{
							count[4]=count[4]+1;
							indicator=1;
						}

					//case 6, accept H (-) -
					if( (i<looknum-1) && (indicator!=1) && (workarray1[k]<-lowerbound1[k]) && (workarray1[k]>-upperbound1[k]) && (workarray2[k]<-upperbound2[k]) ) {
						count[5]=count[5]+1;
						indicator=1;
						
					}

					//if in the continuity region, then move to the next one.
					k=k+1;
				}


	} // The loop ending here runs first to the simul_look elements.
	  // Each element consists of two endpoints.


	for(l=0; l<6; l++)
		count[l]=count[l]/simul_look;  //change from count to probability

	return count;
}




//
//	The main function corresponding to non Symmetric decision rule:
//

// mainly copy from Design_Symm_Normal

// the main difference is in the counting for beta process
// since in the count for alpha, there is no decision consistent with H00

// we still use the same count function, however calculate beta DIFFERENTLY.

//  all six different cases:
//  Accept H -*,  Region 1
//  Accept H +*,  Region 2
//  Accept H 0+,  Region 3
//  Accept H 0-,  Region 4
//  Accept H 00,  Region 5
//  Accept H (-)- Region 6



void Design_NonSymm_Normal(EndNormal * end1, EndNormal * end2 )
// No input needed here,
{
	int look_num, simul_look;
	look_num= end1->num_look;
	simul_look= end1->look_simul;

	double Bi_Alpha = end1->Bi_Alpha;
	double Bi_Beta = end1->Bi_Beta;

	int numofAlter=9;			//number of alternatives.
	int numofRegion=9;           // To avoid mis-counting the regions.
	double c_lower, c_mid, c_upper;  // The constant we are looking for.
	double alpha_upper, alpha_mid, alpha_lower; // the working alpha corresponding to c_lower....	
	
	double *simul1, *simul2;			 // Two endpoint
	double *simulNull1, *simulNull2;	 // Two simulated Null.
	double *simulAlter1, *simulAlter2;   //simulated alternative for each endpoints
	simul1=new double[2*look_num*simul_look];
	simul2=new double[2*look_num*simul_look];
	simulNull1=new double[look_num*simul_look];
	simulNull2=new double[look_num*simul_look];
	simulAlter1=new double[look_num*simul_look];
	simulAlter2=new double[look_num*simul_look];

	simul1=end1->NullAlterGenerator1();
	simul2=end2->NullAlterGenerator1();

	int ini1, ini2;
	for(ini1=0; ini1<simul_look; ini1++){
		for(ini2=0; ini2<look_num; ini2++) {
			simulNull1[ini1*look_num+ini2]=simul1[ini1*look_num+2*ini2];
			simulNull2[ini1*look_num+ini2]=simul2[ini1*look_num+2*ini2];
			simulAlter1[ini1*look_num+ini2]=simul1[ini1*look_num+2*ini2+1];
			simulAlter2[ini1*look_num+ini2]=simul2[ini1*look_num+2*ini2+1];
		}
	}


	double *AlterMean1 = new double[simul_look];
	double *AlterMean2 = new double[simul_look];
	
	int worksize;		

	double betaFunc=0.0;		// Type two error. 
	double alphaFunc=0.0;      // Type one error. 

	double *betaWork;       // Work Beta function; since we have multiple alternative
	double *workProb;     // The working probability array.
	double *workProbNull;
	double *workProbAlter;
	double *workProbAlpha;


	betaWork=new double[9];            // num of alternatives.
//	workProb=new double[numofRegion ];
	workProbNull=new double[6];      //corresponding to nine cases from previous function
	workProbAlter=new double[6];
	workProbAlpha=new double[6];

	

	double *workBoundary1, *workBoundary2;
	workBoundary1=new double[look_num*2];
	workBoundary2=new double[look_num*2];

	int i, j, k,  m;

	for(i=0; i<2*look_num; i++) {
		workBoundary1[i]=end1->boundary[i];
		workBoundary2[i]=end2->boundary[i];
	}

	worksize=maxm(end1->sample_size, end2->sample_size);

	//while we can not satisfy the beta requirement

	int sizeup, sizelow, sizemiddle;
	sizemiddle=worksize;

	int signcontinue=0;
	int c_midsign=0;

	int jj=0;
	double *checkbeta;
	checkbeta=new double[10000];
	int stopsign=0;

	while( stopsign==0 )  {
		//Calculate for the alpha:

		for(i=0; i<look_num; i++){
			AlterMean1[i]=end1->mean_Alter*sqrt(worksize*end1->inform_time[i]);
			AlterMean2[i]=end2->mean_Alter*sqrt(worksize*end2->inform_time[i]);
		}

//		int con3;

		// the loop searching for constant c:
		// if c_midsign=0, then search; else do not do it:
		if( c_midsign==0 ) {
			workProbNull=nonsymm_prob_count(workBoundary1, simulNull1,
										 workBoundary2, simulNull2, end1);

			alphaFunc=1-workProbNull[4];  // Outside of the H00 Region
		
			c_mid=1.0;
		
			// Search for c_lower and c_upper first:
			c_lower=c_mid;
			c_upper=c_mid;

			alpha_lower=alphaFunc;
			alpha_upper=alphaFunc;

			double *meantemp;
			int t1, t2;
			meantemp=new double[end1->num_look];
			for(t1=0; t1<end1->num_look; t1++){
				meantemp[t1]=0;
				for(t2=0; t2<end1->look_simul; t2++){
					meantemp[t1]=meantemp[t1]+simulNull1[t2*end1->num_look+t1];
				}
				meantemp[t1]=meantemp[t1]/end1->look_simul;
			}

	//		mean of simulNull1 is 0.

			while( alpha_upper-Bi_Alpha>0.001 ) {

				c_upper=1.2*c_upper;
				for(m=0; m<look_num; m++) {
					workBoundary1[m]=end1->boundary[m]*c_upper;
					workBoundary2[m]=end2->boundary[m]*c_upper;
				}
			
				workProbAlpha=nonsymm_prob_count(workBoundary1, simulNull1, workBoundary2, simulNull2, end1);
				alpha_upper=1-workProbAlpha[4];
			}

			while( alpha_lower-Bi_Alpha<0.001 ){
				c_lower=c_lower/1.2;
				cout<<"c_lower"<<"\t"<<c_lower<<endl;
				for(m=0; m<2*look_num; m++)	{
					workBoundary1[m]=end1->boundary[m]*c_lower;
					workBoundary2[m]=end2->boundary[m]*c_lower;
				}
				
				workProbAlpha=nonsymm_prob_count(workBoundary1, simulNull1, workBoundary2, simulNull2, end1);
				alpha_lower=1-workProbAlpha[4];

			}

			// First calculation of c_mid

			c_mid=(c_lower+c_upper)/2;
			for(m=0; m<2*look_num; m++)	{
				workBoundary1[m]=end1->boundary[m]*c_mid;
				workBoundary2[m]=end2->boundary[m]*c_mid;
			}
				
			workProbAlpha=nonsymm_prob_count(workBoundary1, simulNull1, workBoundary2, simulNull2, end1);
			alphaFunc=1-workProbAlpha[4];

			while( absd(alphaFunc-end1->Bi_Alpha) > 0.002 ) {
		
				if(alphaFunc < end1->Bi_Alpha){
					c_upper=c_mid;
				}

				if(alphaFunc > end1->Bi_Alpha) {
					c_lower=c_mid;
				}
			
				c_mid=(c_lower+c_upper)/2;
				for(m=0; m<2*look_num; m++){
					workBoundary1[m]=end1->boundary[m]*c_mid;
					workBoundary2[m]=end2->boundary[m]*c_mid;
				}	

				workProbAlpha=nonsymm_prob_count(workBoundary1, simulNull1, workBoundary2, simulNull2, end1);
			
				alphaFunc=1-workProbAlpha[4];

			}

			c_midsign=1;
		}
		else if(c_midsign==1)
			c_mid=c_mid;
	
		double *alterworkbound1, *alterworkbound2;
		alterworkbound1=new double[2*look_num];
		alterworkbound2=new double[2*look_num];

		for(m=0; m<2*look_num;m++) {
			alterworkbound1[m]=end1->boundary[m]*c_mid;
			alterworkbound2[m]=end2->boundary[m]*c_mid;
		}


	// the count for beta:
	for(k=0; k<9; k++)
		betaWork[k]=0;
	
	
	//count 1: Alternative: 0  +
	//count consistent with 0 + is: count 2
	if( end1->ctrl_ind[2]==1 ){
		for(j=0; j<simul_look; j++)
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]+0;
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]+AlterMean2[k];
					}
			}
		double *checkend2;
		checkend2=new double[(look_num+2)*look_num];
		workProbAlter=nonsymm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[1]=1-workProbAlter[2];
	}

	//count 2: Alternative: 0 -
	//count consistent with 0 - is : count 3 
	if( end1->ctrl_ind[3]==1 ){
		for(j=0; j<simul_look; j++)
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]+0;
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]-AlterMean2[k];
					}
			}

		workProbAlter=nonsymm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[2]=1-workProbAlter[3];
	}

	//count 3: Alternative: + 0
	//count consistent with + 0 is: count 1
	if( end1->ctrl_ind[1]==1 ){
		for(j=0; j<simul_look; j++)
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]+AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]-0;
					}
			}

		workProbAlter=nonsymm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[3]=1-workProbAlter[1];
	}

	//count 4; Alternative: - 0
	//count consistent with - 0 is: count 0
	if(end1->ctrl_ind[0]==1){
		for(j=0; j<simul_look; j++)
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]-AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]-0;
					}
			}

		workProbAlter=nonsymm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[4]=1-workProbAlter[0];
	}

	//count 5: alternative + +
	//count consistent with + + is : count 1
	if(end1->ctrl_ind[5]==1){
		for(j=0; j<simul_look; j++)
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]+AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]+AlterMean2[k];
					}
			}

		workProbAlter=nonsymm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);
		betaWork[5]=1-workProbAlter[1];
	}

	//count 6: alternative + -
	//count consistent with + - is: count 1
	if(end1->ctrl_ind[7]==1){
		for(j=0; j<simul_look; j++)
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]+AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]-AlterMean2[k];
					}
			}

		workProbAlter=nonsymm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);

		betaWork[6]=1-workProbAlter[1];
	}

	//count 7: alternative - +
	//count consistent with - + is: count 0
	if(end1->ctrl_ind[4]==1){
		for(j=0; j<simul_look; j++)
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]-AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]+AlterMean2[k];
					}
			}

		workProbAlter=nonsymm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);

		betaWork[7]=1-workProbAlter[0];
	}

	//count 8: alternative - -
	//count consistent with - - is: count 0 and 5 
	if(end1->ctrl_ind[6]==1){
		for(j=0; j<simul_look; j++)
			{
				for(k=0; k<look_num; k++)
					{
						simulAlter1[j*look_num+k]=simulNull1[j*look_num+k]-AlterMean1[k];
						simulAlter2[j*look_num+k]=simulNull2[j*look_num+k]-AlterMean2[k];
					}
		}  

		workProbAlter=nonsymm_prob_count(alterworkbound1, simulAlter1, 
				alterworkbound2, simulAlter2, end1);

		betaWork[8]=1-workProbAlter[0]-workProbAlter[5];
	}

//	for(k=1; k<9; k++)
//		cout<<betaWork[k]<<"\t";
//	cout<<endl;

	betaFunc=0;
	for(k=1; k<9; k++){
		if( betaWork[k]>betaFunc )
			betaFunc=betaWork[k];
	}

	checkbeta[jj]=betaFunc;
	double temp1;
	

//	cout<<"betaFunc"<<"\t"<<betaFunc<<"worksize\t"<<worksize<<endl;

	if(jj>0)
		temp1=(checkbeta[jj]-Bi_Beta)*(checkbeta[jj-1]-Bi_Beta);
	else 
		temp1=1;
	jj=jj+1;

	if( betaFunc > Bi_Beta) {
		if( temp1 <0)
			stopsign=1;
		worksize=worksize+1;
	}
	if(betaFunc < Bi_Beta) {
		if(temp1 <0)
			stopsign=1;
		worksize=worksize-1;
	}
	}

	end1->sample_size=worksize;
	end2->sample_size=worksize;

	for(i=0; i<end1->num_look; i++){
		end1->lower_bound[i]=end1->lower_bound[i]*c_mid;
		end1->upper_bound[i]=end1->upper_bound[i]*c_mid;
		end2->lower_bound[i]=end2->lower_bound[i]*c_mid;
		end2->upper_bound[i]=end2->upper_bound[i]*c_mid;
	}

	for(i=0; i<2*end1->num_look; i++){
		end1->boundary[i]=end1->boundary[i]*c_mid;
		end2->boundary[i]=end2->boundary[i]*c_mid;
	}

}












//
//	In the case of two Survival:
//	
//  Two working: SurvivalEnd1, SurvivalEnd2;
EndNormal *SurNormalA1, *SurNormalA2;
void TwoSurvival()
{
	int i;
//	int con1;
	SurNormalA1=new EndNormal;
	SurNormalA2=new EndNormal;

	// Initialize information:
	double *informationall;
	informationall=new double[2*SurvivalEnd1->num_look];

	informationall=SSInfoNew(0,0);

	// Calculate boundary and samplesize:
	SurvivalEnd1->Choice();
	SurvivalEnd2->Choice();

	// The check procedure of SurvivalEnd1 & SurvivalEnd2:

	// Initialize SurNormalA1 & SurNormalA2;

	for(i=0; i<8; i++){
		SurNormalA1->ctrl_ind[i]=SurvivalEnd1->ctrl_ind[i];
		SurNormalA2->ctrl_ind[i]=SurvivalEnd2->ctrl_ind[i];
	}

	SurNormalA1->order=1;
	SurNormalA2->order=2;
	SurNormalA1->num_look=SurvivalEnd1->num_look;
	SurNormalA2->num_look=SurvivalEnd1->num_look;
	SurNormalA1->num_simul=SurvivalEnd1->num_simul;
	SurNormalA2->num_simul=SurvivalEnd2->num_simul;
	SurNormalA1->look_simul=SurvivalEnd1->num_simul/SurvivalEnd1->num_look;
	SurNormalA2->look_simul=SurvivalEnd2->num_simul/SurvivalEnd1->num_look;
	SurNormalA1->mean_Null=0;
	SurNormalA2->mean_Null=0;
	SurNormalA1->mean_Alter=absd(log(SurvivalEnd1->lambdaAlter/SurvivalEnd1->lambdaNull)/log(2.7182818284))*sqrt(SurvivalEnd1->prop);
	SurNormalA2->mean_Alter=absd(log(SurvivalEnd2->lambdaAlter/SurvivalEnd2->lambdaNull)/log(2.7182818284))*sqrt(SurvivalEnd2->prop);
	SurNormalA1->var_Null=1;
	SurNormalA2->var_Null=1;
	SurNormalA1->var_Alter=1;
	SurNormalA2->var_Alter=1;

	SurNormalA1->rule_decision=SurvivalEnd1->rule_decision;
	SurNormalA2->rule_decision=SurvivalEnd2->rule_decision;
	
	for(i=0; i<SurvivalEnd1->num_look; i++){
		SurNormalA1->inform_time[i]=informationall[i];
		SurNormalA2->inform_time[i]=informationall[i+SurvivalEnd1->num_look];
	}

	SurNormalA1->overall_alpha=SurvivalEnd1->alpha;
	SurNormalA2->overall_alpha=SurvivalEnd2->alpha;
	SurNormalA1->overall_beta=SurvivalEnd1->beta;
	SurNormalA2->overall_beta=SurvivalEnd2->beta;

	SurNormalA1->spending_num=SurvivalEnd1->alphaSpend;
	SurNormalA2->spending_num=SurvivalEnd2->alphaSpend;

	for(i=0; i<SurvivalEnd1->num_look; i++){
		SurNormalA1->alpha[i]=SurvivalEnd1->alpha_spending[i];
		SurNormalA2->alpha[i]=SurvivalEnd2->alpha_spending[i];
		SurNormalA1->beta[i]=SurvivalEnd1->beta_spending[i];
		SurNormalA2->beta[i]=SurvivalEnd2->beta_spending[i];
	}

	for(i=0; i<SurvivalEnd1->num_look; i++){
		SurNormalA1->upper_bound[i]=SurvivalEnd1->upperbound[i];
		SurNormalA2->upper_bound[i]=SurvivalEnd2->upperbound[i];
		SurNormalA1->lower_bound[i]=SurvivalEnd1->lowerbound[i];
		SurNormalA2->lower_bound[i]=SurvivalEnd2->lowerbound[i];
	}

	for(i=0; i<2*SurvivalEnd1->num_look; i++){
		SurNormalA1->boundary[i]=SurvivalEnd1->boundary[i];
		SurNormalA2->boundary[i]=SurvivalEnd2->boundary[i];
	}

	SurNormalA1->sample_size=SurvivalEnd1->samplesize;
	SurNormalA2->sample_size=SurvivalEnd2->samplesize;
	
	SurNormalA1->Bi_Alpha=SurvivalEnd1->Bi_Alpha;
	SurNormalA2->Bi_Alpha=SurvivalEnd2->Bi_Alpha;
	SurNormalA1->Bi_Beta=SurvivalEnd1->Bi_Beta;
	SurNormalA2->Bi_Beta=SurvivalEnd1->Bi_Beta;
	// Initialize finished

	// hard versus soft decision:

	if(SurvivalEnd1->rule_decision==1)
		Design_Symm_Normal(SurNormalA1, SurNormalA2);
	else if(SurvivalEnd1->rule_decision==0)
		Design_NonSymm_Normal(SurNormalA1, SurNormalA2);

	SurvivalEnd1->samplesize=SurNormalA1->sample_size;
	SurvivalEnd2->samplesize=SurNormalA1->sample_size;
	
	for(i=0; i<SurvivalEnd1->num_look; i++){
		SurvivalEnd1->upperbound[i]=SurNormalA1->upper_bound[i];
		SurvivalEnd1->lowerbound[i]=SurNormalA1->lower_bound[i];
		SurvivalEnd2->upperbound[i]=SurNormalA2->upper_bound[i];
		SurvivalEnd2->lowerbound[i]=SurNormalA2->lower_bound[i];
	}

	for(i=0; i<SurvivalEnd1->num_look*2; i++){
		SurvivalEnd1->boundary[i]=SurNormalA1->boundary[i];
		SurvivalEnd2->boundary[i]=SurNormalA2->boundary[i];
	}

}



// Output the EndNormal type end:
void OutNormal(EndNormal *end1)
{
	int i;

	cout<<"order"<<"\t"<<end1->order<<endl;
	cout<<"Decision rule"<<"\t"<<end1->rule_decision<<endl;
	cout<<"numoflook"<<"\t"<<end1->num_look<<"\t";
	cout<<"num of simul"<<"\t"<<end1->num_simul<<"\t";
	cout<<"look simul"<<"\t"<<end1->look_simul<<endl;
	cout<<"mean Null"<<"\t"<<end1->mean_Null<<"\t"<<"var Null"<<"\t"<<end1->var_Null<<endl;
	cout<<"mean Alter"<<"\t"<<end1->mean_Alter<<"\t"<<"var Alter"<<"\t"<<end1->var_Alter<<endl;
	cout<<"Information"<<"\t";
	for(i=0; i<end1->num_look; i++)
		cout<<end1->inform_time[i]<<"\t";
	cout<<endl<<"Alpha"<<"\t";
	for(i=0; i<end1->num_look; i++)
		cout<<end1->alpha[i]<<"\t";
	cout<<endl<<"Beta"<<"\t";
	for(i=0; i<end1->num_look; i++)
		cout<<end1->beta[i]<<"\t";

	cout<<endl<<"upperbound"<<"\t";
	for(i=0; i<end1->num_look; i++)
		cout<<end1->upper_bound[i]<<"\t";
	cout<<endl<<"lowerbound"<<"\t";
	for(i=0; i<end1->num_look; i++)
		cout<<end1->lower_bound[i]<<"\t";
	cout<<endl<<"samplesize"<<"\t"<<end1->sample_size;
	cout<<endl<<"Bi_Alpha"<<"\t"<<end1->Bi_Alpha<<"\t"<<"Bi_Beta"<<"\t"<<end1->Bi_Beta<<endl;	

}




//
//	In the case of one Normal and one Survival:
//			NormalEnd1, SurvivalEnd1;
EndNormal *NSEnd1, *NSEnd2;
void NorSurvival()
{

//	int con1;
	int i, j;

	NSEnd1=new EndNormal;
	NSEnd2=new EndNormal;

	// Initialize NSEnd1:
	NSEnd1->order=1;

	NSEnd1->rule_decision=NormalEnd1->rule_decision;

	NSEnd1->num_look=NormalEnd1->num_look;
	NSEnd1->num_simul=NormalEnd1->num_simul;
	NSEnd1->look_simul=NormalEnd1->num_simul/NormalEnd1->num_look;

	NSEnd1->mean_Null=NormalEnd1->mean_Null;
	NSEnd1->mean_Alter=NormalEnd1->mean_Alter;
	NSEnd1->var_Null=NormalEnd1->var_Null;
	NSEnd1->var_Alter=NormalEnd1->var_Alter;

	for(i=0; i<NSEnd1->num_look; i++){
		NSEnd1->event_look[i]=NormalEnd1->event_look[i];
		NSEnd1->inform_time[i]=NormalEnd1->inform_time[i]/NormalEnd1->inform_time[NormalEnd1->num_look-1];
	}

	NSEnd1->overall_alpha=NormalEnd1->overall_alpha;
	NSEnd1->overall_beta=NormalEnd1->overall_beta;
	NSEnd1->spending_num=NormalEnd1->spending_num;

	NSEnd1->SizeAdjust();


	NSEnd1->corr_ph=NormalEnd1->corr_ph;

	NSEnd1->Bi_Alpha=NormalEnd1->Bi_Alpha;

	NSEnd1->Bi_Beta=NormalEnd1->Bi_Beta;

	for(i=0; i<8; i++){
		NSEnd1->ctrl_ind[i]=NormalEnd1->ctrl_ind[i];
		NSEnd2->ctrl_ind[i]=SurvivalEnd2->ctrl_ind[i];
	}

	// Initialize NSEnd2:

	NSEnd2->order=2;

	NSEnd2->rule_decision=SurvivalEnd2->rule_decision;

	NSEnd2->num_look=SurvivalEnd2->num_look;
	NSEnd2->num_simul=SurvivalEnd2->num_simul;
	NSEnd2->look_simul=SurvivalEnd2->num_simul/SurvivalEnd2->num_look;

	NSEnd2->mean_Null=0;
	NSEnd2->mean_Alter=absd(log(SurvivalEnd2->lambdaAlter/SurvivalEnd2->lambdaNull));
	NSEnd2->var_Null=1;
	NSEnd2->var_Alter=1;

	NSEnd2->overall_alpha=SurvivalEnd2->alpha;
	NSEnd2->overall_beta=SurvivalEnd2->beta;

	for(i=0; i<NSEnd2->num_look; i++)
		NSEnd2->inform_time[i]=SurvivalEnd2->inform_time[i]/SurvivalEnd2->inform_time[SurvivalEnd2->num_look-1];

	NSEnd2->spending_num=SurvivalEnd2->alphaSpend;

	SurvivalEnd2->Choice();

	for(i=0; i<SurvivalEnd2->num_look; i++){
		NSEnd2->alpha[i]=SurvivalEnd2->alpha_spending[i];
		NSEnd2->beta[i]=SurvivalEnd2->beta_spending[i];
		NSEnd2->upper_bound[i]=SurvivalEnd2->upperbound[i];
		NSEnd2->lower_bound[i]=SurvivalEnd2->lowerbound[i];
	}

	for(j=0; j<SurvivalEnd2->num_look*2; j++)
		NSEnd2->boundary[j]=SurvivalEnd2->boundary[j];

	NSEnd2->sample_size=SurvivalEnd2->samplesize;

	NSEnd2->Bi_Alpha=SurvivalEnd2->Bi_Alpha;
	NSEnd2->Bi_Beta=SurvivalEnd2->Bi_Beta;

	NormalDecisionRule(NSEnd1, NSEnd2);

	NormalEnd1->sample_size=NSEnd1->sample_size;
	SurvivalEnd2->samplesize=NSEnd2->sample_size;

	for(i=0; i<NormalEnd1->num_look; i++){
		NormalEnd1->upper_bound[i]=NSEnd1->upper_bound[i];
		NormalEnd1->lower_bound[i]=NSEnd1->lower_bound[i];
		SurvivalEnd2->upperbound[i]=NSEnd2->upper_bound[i];
		SurvivalEnd2->lowerbound[i]=NSEnd2->lower_bound[i];
	}

	for(i=0; i<NormalEnd1->num_look*2; i++){
		NormalEnd1->boundary[i]=NSEnd1->boundary[i];
		SurvivalEnd2->boundary[i]=NSEnd2->boundary[i];
	}
}







//
//	The case of Survival - Normal
//
EndNormal *SNEnd1, *SNEnd2;
void SurNormal()
{
	int i, j;
	SNEnd1=new EndNormal;
	SNEnd2=new EndNormal;

	// Initialize NSEnd1:
	for(i=0; i<8; i++){
		SNEnd1->ctrl_ind[i]=SurvivalEnd1->ctrl_ind[i];
		SNEnd2->ctrl_ind[i]=NormalEnd2->ctrl_ind[i];
	}

	SNEnd1->order=1;

	SNEnd1->rule_decision=SurvivalEnd1->rule_decision;

	SNEnd1->num_look=SurvivalEnd1->num_look;
	SNEnd1->num_simul=SurvivalEnd1->num_simul;
	SNEnd1->look_simul=SurvivalEnd1->num_simul/SurvivalEnd1->num_look;

	SNEnd1->mean_Null=0;
	SNEnd1->mean_Alter=absd(log(SurvivalEnd1->lambdaAlter/SurvivalEnd1->lambdaNull));
	SNEnd1->var_Null=1;
	SNEnd1->var_Alter=1;

	SNEnd1->overall_alpha=SurvivalEnd1->alpha;
	SNEnd1->overall_beta=SurvivalEnd1->beta;

	for(i=0; i<SNEnd1->num_look; i++)
		SNEnd1->inform_time[i]=SurvivalEnd1->inform_time[i]/SurvivalEnd1->inform_time[SurvivalEnd1->num_look-1];

	SNEnd1->spending_num=SurvivalEnd1->alphaSpend;

	SurvivalEnd1->Choice();

	for(i=0; i<SurvivalEnd1->num_look; i++){
		SNEnd1->alpha[i]=SurvivalEnd1->alpha_spending[i];
		SNEnd1->beta[i]=SurvivalEnd1->beta_spending[i];
		SNEnd1->upper_bound[i]=SurvivalEnd1->upperbound[i];
		SNEnd1->lower_bound[i]=SurvivalEnd1->lowerbound[i];
	}

	for(j=0; j<SurvivalEnd1->num_look*2; j++)
		SNEnd1->boundary[j]=SurvivalEnd1->boundary[j];

	SNEnd1->sample_size=SurvivalEnd1->samplesize;

	SNEnd1->Bi_Alpha=SurvivalEnd1->Bi_Alpha;
	SNEnd1->Bi_Beta=SurvivalEnd1->Bi_Beta;

	// Initialize SNEnd2:
	SNEnd2->order=2;
	
	SNEnd2->rule_decision=NormalEnd2->rule_decision;

	SNEnd2->num_look=NormalEnd2->num_look;
	SNEnd2->num_simul=NormalEnd2->num_simul;
	SNEnd2->look_simul=NormalEnd2->num_simul/NormalEnd2->num_look;

	SNEnd2->mean_Null=NormalEnd2->mean_Null;
	SNEnd2->mean_Alter=NormalEnd2->mean_Alter;
	SNEnd2->var_Null=NormalEnd2->var_Null;
	SNEnd2->var_Alter=NormalEnd2->var_Alter;

	for(i=0; i<SNEnd2->num_look; i++){
		SNEnd2->event_look[i]=NormalEnd2->event_look[i];
		SNEnd2->inform_time[i]=NormalEnd2->inform_time[i]/NormalEnd2->inform_time[NormalEnd2->num_look-1];
	}

	SNEnd2->overall_alpha=NormalEnd2->overall_alpha;
	SNEnd2->overall_beta=NormalEnd2->overall_beta;
	SNEnd2->spending_num=NormalEnd2->spending_num;

	SNEnd2->SizeAdjust();

	SNEnd2->corr_ph=NormalEnd2->corr_ph;

	SNEnd2->Bi_Alpha=NormalEnd2->Bi_Alpha;

	SNEnd2->Bi_Beta=NormalEnd2->Bi_Beta;

	NormalDecisionRule(SNEnd1, SNEnd2);

	SurvivalEnd1->samplesize=SNEnd1->sample_size;
	NormalEnd2->sample_size=SNEnd2->sample_size;
	
	for(i=0; i<SurvivalEnd1->num_look; i++){
		SurvivalEnd1->upperbound[i]=SNEnd1->upper_bound[i];
		SurvivalEnd1->lowerbound[i]=SNEnd1->lower_bound[i];
		NormalEnd2->upper_bound[i]=SNEnd2->upper_bound[i];
		NormalEnd2->lower_bound[i]=SNEnd2->lower_bound[i];
	}

	for(i=0; i<SurvivalEnd1->num_look; i++){
		SurvivalEnd1->boundary[2*i]=SNEnd1->lower_bound[i];
		SurvivalEnd1->boundary[2*i+1]=SNEnd1->upper_bound[i];
		NormalEnd2->boundary[2*i]=SNEnd2->lower_bound[i];
		NormalEnd2->boundary[2*i+1]=SNEnd2->upper_bound[i];
	}

}


// the new version of information transformation
// Sep 15th, 2002
double * SSInfoNew(int end1, int end2)
{
	double *information1;	// information for end 1
	double *information2;	// information for end 2
	double *calendar;		// calendar time
	double *informationall;	// the return value.
	
	information1=new double[SurvivalEnd1->num_look];
	information2=new double[SurvivalEnd1->num_look];
	calendar=new double[SurvivalEnd1->num_look];
	informationall=new double[2*SurvivalEnd1->num_look];

//	int con1;
	int i, j;

	for(i=0; i<SurvivalEnd1->num_look; i++) {
		information1[i]=SurvivalEnd1->inform_time[i]/SurvivalEnd1->inform_time[SurvivalEnd1->num_look-1];
	}

	double Tentry, Tfollow, endTime;
	Tentry=SurvivalEnd1->entry;
	Tfollow=SurvivalEnd1->followup;
	endTime=Tentry+Tfollow;

	double lambda_null1, lambda_null2, lambda_alter1, lambda_alter2;

	lambda_null1=SurvivalEnd1->lambdaNull;
	lambda_alter1=SurvivalEnd1->lambdaAlter;
	lambda_null2=SurvivalEnd2->lambdaNull;
	lambda_alter2=SurvivalEnd2->lambdaAlter;

	int simul1=5000;
	int seed1= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
	long* idum1=new long(seed1);
	int seed2= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
	long* idum2=new long(seed2);
	int seed3= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
	long* idum3=new long(seed3);
	int seed4= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
	long* idum4=new long(seed4);


	double *entryTime1, *entryTime2;	// control and treat entry time
	double *event11, *event12;	// end 1 control and treat
	double *event21, *event22;	// end 2 control and treat

	double *over11, *over12;	// entry + event, end 1
	double *over21, *over22;	// entry + event, end 2

	double *over1, *over2;	// entry + event, end 1 AND end 2

	entryTime1=new double[simul1];
	entryTime2=new double[simul1];
	event11=new double[simul1];
	event12=new double[simul1];
	event21=new double[simul1];
	event22=new double[simul1];
	over11=new double[simul1];
	over12=new double[simul1];
	over21=new double[simul1];
	over22=new double[simul1];
	over1=new double[2*simul1];
	over2=new double[2*simul1];

	for(i=0; i<simul1; i++){
		entryTime1[i]=Tentry*ranA1(idum1);
		entryTime2[i]=Tentry*ranA1(idum2);
	}

	event11=ExpGeneratorA(simul1, lambda_null1);
	event12=ExpGeneratorA(simul1, lambda_alter1);
	event21=ExpGeneratorA(simul1, lambda_null2);
	event22=ExpGeneratorA(simul1, lambda_alter2);

	int count1=0, count2=0;	// total number of event for end 1 & end 2
	int *eventEnd1, *eventEnd2;		
	eventEnd1=new int[SurvivalEnd1->num_look];	// number of event by each look end 1
	eventEnd2=new int[SurvivalEnd1->num_look];	//								end 2

	for(i=0; i<simul1; i++){
		// end 1 (control)
		if( entryTime1[i]+event11[i] > endTime ){
			over11[i]=endTime;
			count1=count1+0;
		}
		if( entryTime1[i]+event11[i] <= endTime ){
			over11[i]=entryTime1[i]+event11[i];
			count1=count1+1;
		}
		// end 1 (treat)
		if( entryTime2[i]+event12[i] > endTime ){
			over12[i]=endTime;
			count1=count1+0;
		}
		if( entryTime2[i]+event12[i] <= endTime ){
			over12[i]=entryTime2[i]+event12[i];
			count1=count1+1;
		}


		// end 2 (control)
		if( entryTime1[i]+event21[i] > endTime ){
			over21[i]=endTime;
			count2=count2+0;
		}
		if( entryTime1[i]+event21[i] <= endTime ){
			over21[i]=entryTime2[i]+event21[i];
			count2=count2+1;
		}
		// end 2 (treat)
		if( entryTime2[i]+event22[i] > endTime ){
			over22[i]=endTime;
			count2=count2+0;
		}
		if( entryTime2[i]+event22[i] <= endTime ){
			over22[i]=entryTime2[i]+event22[i];
			count2=count2+1;
		}		
	}

	for(i=0; i<SurvivalEnd1->num_look; i++)
		eventEnd1[i]=(int) count1* information1[i];

	for(i=0; i<simul1; i++){
		over1[i]=over11[i];			// end 1 control
		over1[i+simul1]=over12[i];	// end 1 treat
		over2[i]=over21[i];			// end 2 control
		over2[i+simul1]=over22[i];	// end 2 treat
	}

	mySort(over1, 2*simul1);
	mySort(over2, 2*simul1);

	// Now find the calendar time:
	for( i=0; i< SurvivalEnd1->num_look-1; i++){
		calendar[i]=over1[ eventEnd1[i] ];
	}
	calendar[SurvivalEnd1->num_look-1]=endTime;
	
//	cout<<"check the calender time and EndTime"<<endl;
//	for(i=0; i<SurvivalEnd1->num_look; i++){
//		cout<<calendar[i]<<"\t";
//	}
//	cout<<"\t"<<"Endtime"<<"\t"<<endTime<<endl;
//	cin>>con1;

	// Now find the information2;
	for(i=0; i<SurvivalEnd1->num_look; i++)
		information2[i]=0;

	for(i=0; i<SurvivalEnd1->num_look-1; i++){
		double counttemp=0;
		for(j=0; j<2*simul1; j++) {
			if(over2[j]<=calendar[i]){
				counttemp=counttemp+1;
			}
		}
		information2[i]=counttemp;
//		cout<<"counttemp"<<"\t"<<counttemp<<"\t";
	}
	information2[SurvivalEnd1->num_look-1]=count2;
	for(i=0; i<SurvivalEnd1->num_look;i++){
		information2[i]=information2[i]/information2[SurvivalEnd1->num_look-1];
	}

//	cout<<count2<<endl;

	for(i=0; i<SurvivalEnd1->num_look; i++){
		informationall[i]=information1[i];
		informationall[i+SurvivalEnd1->num_look]=information2[i];
	}
	
//	cout<<"check of information transformation: new version"<<endl;
//	cout<<"information 1"<<"\t";
//	for(i=0; i<SurvivalEnd1->num_look; i++){
//		cout<<information1[i]<<"\t";
//	}
//	cout<<endl<<"information 2"<<"\t";
//	for(i=0; i<SurvivalEnd1->num_look; i++){
//		cout<<information2[i]<<"\t";
//	}
//	cin>>i;
	return informationall;
	
}



double * SSInfo(int end1, int end2)
{
	double *information1;
	double *information2;
	double *calendar;
	double *informationall;

	information1=new double[SurvivalEnd1->num_look];
	information2=new double[SurvivalEnd1->num_look];
	calendar=new double[SurvivalEnd1->num_look];
	informationall=new double[2*SurvivalEnd1->num_look];

	int i, j;

	for(i=0; i<SurvivalEnd1->num_look; i++) {
		information1[i]=SurvivalEnd1->inform_time[i]/SurvivalEnd1->inform_time[SurvivalEnd1->num_look-1];
	}

	double Tentry, Tfollow, endTime;
	Tentry=SurvivalEnd1->entry;
	Tfollow=SurvivalEnd1->followup;
	endTime=Tentry+Tfollow;
	
	double lambda1, lambda2;
	// where 0 stands for Null  1 stands for Alter;
	if(end1==0 && end1==0){
		lambda1=SurvivalEnd1->lambdaNull;
		lambda2=SurvivalEnd2->lambdaNull;
	}
	if(end1==0 && end1==1){
		lambda1=SurvivalEnd1->lambdaNull;
		lambda2=SurvivalEnd2->lambdaAlter;
	}
	if(end1==1 && end1==0){
		lambda1=SurvivalEnd1->lambdaAlter;
		lambda2=SurvivalEnd2->lambdaNull;
	}
	if(end1==1 && end1==1){
		lambda1=SurvivalEnd1->lambdaAlter;
		lambda2=SurvivalEnd2->lambdaAlter;
	}

	int simul1=10000;
	int seed1= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
	long* idum1=new long(seed1);
	int seed2= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
	long* idum2=new long(seed1);


	double *entryTime;
	double *eventTime1, *eventTime2;
	double *overall1, *overall2;
	entryTime=new double[simul1];
	eventTime1=new double[simul1];
	eventTime2=new double[simul1];
	overall1=new double[simul1];
	overall2=new double[simul1];
	
	for(i=0; i<simul1; i++){
		entryTime[i]=Tentry*ranA1(idum1);
	}
	eventTime1=ExpGeneratorA(simul1, lambda1);
	eventTime2=ExpGeneratorA(simul1, lambda2);
	
	int count1=0, count2=0;
	int *eventEnd1, *eventEnd2;
	eventEnd1=new int[SurvivalEnd1->num_look];
	eventEnd2=new int[SurvivalEnd1->num_look];

	for(i=0; i<simul1; i++){
		if( entryTime[i]+eventTime1[i] > endTime ){
			overall1[i]=endTime;
			count1=count1+0;
		}
		if( entryTime[i]+eventTime1[i] < endTime ){
			overall1[i]=entryTime[i]+eventTime1[i];
			count1=count1+1;
		}

		
		if( entryTime[i]+eventTime2[i] > endTime ){
			overall2[i]=endTime;
			count2=count2+0;
		}
		if( entryTime[i]+eventTime2[i] < endTime ){
			overall2[i]=entryTime[i]+eventTime2[i];
			count2=count2+1;
		}
	}

	for(i=0; i<SurvivalEnd1->num_look; i++)
		eventEnd1[i]=(int) count1* information1[i];

	mySort(overall1, simul1);
	mySort(overall2, simul1);

	// Now find the calendar time:

	for( i=0; i< SurvivalEnd1->num_look; i++){
		calendar[i]=overall1[ eventEnd1[i] ];
	}

	// Now find the information2;
	for(i=0; i<SurvivalEnd1->num_look; i++)
		information2[i]=0;

	for(i=0; i<SurvivalEnd1->num_look; i++){
		double counttemp=0;
		for(j=0; j<simul1; j++) {
			if(overall2[j]< calendar[i]){
				counttemp=counttemp+1;
			}
		}
		information2[i]=counttemp/count2;
	}

	for(i=0; i<SurvivalEnd1->num_look; i++){
		informationall[i]=information1[i];
		informationall[i+SurvivalEnd1->num_look]=information2[i];
	}


	return informationall;
}










double Sample_QuanA(int size, double *array1, double percentage)
{
  double *p;
  int flag=1; // if flag=1, need to do more work
  double tmp, score;
  int count=0, position;
  p=new double[size];  

  p=array1;

  while (flag!=0)
    {
      flag=0;
      for(int i=0; i<size-1-count; i++){
		if(p[i]>p[i+1]){
		tmp=p[i];
		p[i]=p[i+1];
		p[i+1]=tmp;
		flag=1;
		}
      }
      count++;
    }
	
  position=(int) (percentage*(size-1) );

  score=array1[position];
	
  return score;            // Return value is the percentile
}



float ranA1(long *idum)
{	int j;
	long k;
	static long iy=0;
	static long iv[NTAB];
	float temp;

	if (*idum <= 0 || !iy) {		//Initialize.
		if (-(*idum) < 1) *idum=1;	//Be sure to prevent idum = 0.
		else *idum = -(*idum);
		for (j=NTAB+7;j>=0;j--) {	//Load the shu.e table (after 8 warm-ups).
			k=(*idum)/IQ;
			*idum=IA*(*idum-k*IQ)-IR*k;
			if (*idum < 0) *idum += IM;
			if (j < NTAB) iv[j] = *idum;
		}
		iy=iv[0];
	}

	k=(*idum)/IQ;					//Start here when not initializing.
	*idum=IA*(*idum-k*IQ)-IR*k;		//Compute idum=(IA*idum) % IM without over-ows by Schrage's method. 
	if (*idum < 0)	*idum += IM;
	j=iy/NDIV;						//Will be in the range 0..NTAB-1.
	iy=iv[j];						//Output previously stored value and refill the shuffle table. 
	iv[j] = *idum;

	if ((temp=AM*iy) > RNMX) 
		return RNMX;				//Because users don't expect endpoint values.
	else 
		return temp;
}




double* ExpGeneratorA(int size, double lambda1)
{
  double * work_array; 
  double * exp_array;
  int i=0;
  int seed;

  seed= -117*(int) ( (double) ( rand() % 2000) ) / 2000.0;
  work_array=new double[size];
  exp_array=new double[size];


  long* idum=new long(seed);
  
  while(i<size){
	  work_array[i]=ranA1(idum);
	  if(work_array[i] > 0) {
		  exp_array[i]=-(1/lambda1)*log(work_array[i]);
		  i=i+1;
	  }
  }

  return exp_array;
}




void InputBound()
{
	NormalEnd1->order = 1;
	NormalEnd1->num_look=5;
	NormalEnd1->num_simul=50000;
	NormalEnd1->getLookSimul();
	NormalEnd1->mean_Null=0.0;
	NormalEnd1->var_Null=1.0;
	NormalEnd1->mean_Alter=0.33;
	NormalEnd1->var_Alter=1.0;
	NormalEnd1->overall_alpha=0.05;
	NormalEnd1->overall_beta=0.1;
	NormalEnd1->spending_num=1;
	int eventlook1[]={1,2,3,4,5};
	NormalEnd1->event_look=eventlook1;
	NormalEnd1->information();
	NormalEnd1->sample_size=100;


	NormalEnd2->order = 2;
	NormalEnd2->num_look=NormalEnd1->num_look;
	NormalEnd2->num_simul=50000;
	NormalEnd2->getLookSimul();
	NormalEnd2->mean_Null=0.0;
	NormalEnd2->var_Null=1.0;
	NormalEnd2->mean_Alter=0.33;
	NormalEnd2->var_Alter=1.0;
	NormalEnd2->overall_alpha=0.05;
	NormalEnd2->overall_beta=0.1;
	NormalEnd2->spending_num=1;
	int eventlook2[]={1,2,3,4,5};
	NormalEnd2->event_look=eventlook2;
	NormalEnd2->information();

	NormalEnd1->corr_ph=0.0;
	NormalEnd1->Bi_Alpha=0.06;
	NormalEnd1->Bi_Beta=0.1;
	NormalEnd2->corr_ph=NormalEnd1->corr_ph;
	NormalEnd2->Bi_Alpha=NormalEnd1->Bi_Alpha;
	NormalEnd2->Bi_Beta=NormalEnd1->Bi_Beta;
	NormalEnd2->sample_size=100;

	double lowerbound1[]={0.0087, 0.0597, 0.3813, 1.1733, 2.0099};
	double upperbound1[]={3.2554, 2.9854, 2.6900, 2.3708, 2.0099};
	NormalEnd1->lower_bound=lowerbound1;
	NormalEnd1->upper_bound=upperbound1;

	double lowerbound2[]={0.0087, 0.0597, 0.3813, 1.1733, 2.0099};
	double upperbound2[]={3.2554, 2.9854, 2.6900, 2.3708, 2.0099};
	NormalEnd2->lower_bound=lowerbound2;
	NormalEnd2->upper_bound=upperbound2;


	NormalEnd1->makeBoundary(); 

	NormalEnd2->makeBoundary(); 

//	cout<<endl<<"Begin to run Design_Symm_Normal()"<<endl;

	Design_Symm_Normal(NormalEnd1, NormalEnd2);

//	cout<<endl<<"Design_Symm_Normal() Finished."<<endl<<endl;


}


